<?php

// MySQL host name, user name, password, database, and table
if (!defined('WP_PLUGIN_DIR')) exit('No direct script access allowed');
require_once( dirname(__FILE__) . '/MonLabo_admin.php' );

//--------------------------------------------------------------------------------
// Génère le formulaire d'édition de personnes
//--------------------------------------------------------------------------------
function edit_members_form() {
    /*echo("<pre>");
    var_dump($_POST);
    var_dump($_GET);
    echo("</pre>");*/
    require_once( dirname(__FILE__) . '/includes/inc-lib-forms.php' );
    $retval="";
    $MonLabo_access_data = New MonLabo_access_data();

    list($retval, $member_id, $page_id_if_created)=form_edit_member_processing();

    $myurl = admin_url('admin.php?page=MonLabo_edit_members_and_groups&tab=tab_one');

    $members_name_actif = $MonLabo_access_data->get_persons_name($status="actif");
    $members_name_alumni = $MonLabo_access_data->get_persons_name($status="alumni");
    if(!empty($members_name_actif))  {asort($members_name_actif, SORT_STRING);}
    if(!empty($members_name_alumni)) {asort($members_name_alumni, SORT_STRING);}

    //Get member infomation. If invalid of new, return an empty object
    if ($member_id != 0) {
        $member_information = $MonLabo_access_data->get_person_information($member_id);
        //If invalid ID
        if ($member_information===NULL) {
            $member_id=0;
        }
    }
    if ($member_id===0) {
        $member_information = (object) Array("wp_post_id"=>"", "title"=>"", "first_name"=>"", "last_name"=>""
                , "category"=>"", "function_en"=>"", "function_fr"=>"", "id"=>0
                , "date_departure"=>"", "mail"=>"", "room"=>"", "external_url"=>""
                , "phone"=>"", "address_alt"=>"", "descartes_publi_author_id"=>"", "hal_publi_author_id"=>""
                , "uid_ENT_parisdescartes"=>"", "status"=>"", "visible"=>""
                , "custom1"=>"", "custom2"=>"", "custom3"=>"", "custom4"=>"", "custom5"=>""
                , "custom6"=>"", "custom7"=>"", "custom8"=>"", "custom9"=>"", "custom10"=>"");
    }
    $nouveau_membre_string='&mdash; '.__("Nouveau membre", "MonLabo" ).' &mdash;';
    if (is_array($members_name_actif) && array_key_exists($member_id, $members_name_actif)) {
        $valeur_initiale = $members_name_actif[$member_id];
    } elseif (is_array($members_name_alumni) && array_key_exists($member_id, $members_name_alumni)) {
        $valeur_initiale = $members_name_alumni[$member_id];
    } else {
        $valeur_initiale = $nouveau_membre_string;
    }

    // formulaire choix du membre à éditer
    $name = "item";
    $values = Array("0" => $nouveau_membre_string, "Actifs" => $members_name_actif ,"Alumni" => $members_name_alumni);
    $isMandatory = false;
    $legend = __("Membre", "MonLabo");
    $description = "";
    $onchange = "change_member(this.value)";
    $retval.='  <form class="navbar-form" id="choix_membre" method="post" action="'.$myurl.'">
            <div class="form-group">';

    $retval.='<fieldset><legend>'.__("Sélection :", "MonLabo" ).'</legend>';
    $retval.=generate_champ_formulaire_select($name, $values, $isMandatory, $legend, $description, $valeur_initiale, $onchange);
    $retval.='</fieldset></div>';
    $retval.='</form>';
    $retval.='<hr/>';

    // formulaire d'édition du membre
    $retval.='  <form class="navbar-form" id="form_edit_member" accept-charset="utf-8" method="post"
            enctype="multipart/form-data" action="'.$myurl.'&submit_item='.$member_id.'">
            <div class="form-group">';

    // Identité
    //---------
    $retval.='<fieldset class="alignleft"><legend>'.__("Identité :", "MonLabo").'</legend>';
    $retval.='<input type="hidden" name="submit_id" value="'.$member_id.'" />';
    $retval.='<input type="hidden" name="action" id="action" value="" />';
    if ($member_id != 0) {
        $retval.="Id : ".$member_information->id."<br />";
    }
    $retval.=generate_champ_formulaire_select("title", Array(""=>"&nbsp;","Pr."=>"Pr.", "Dr."=>"Dr."), false, _x("Titre","titre honnorifique", "MonLabo")
        , get_MonLabo_Members_fields_comments('title')
        , $member_information->title) ;
    $retval.=generate_champ_formulaire_pub("first_name", true, _x("Prénom","personne", "MonLabo"), get_MonLabo_Members_fields_comments('first_name'),
        $member_information->first_name);
    $retval.=generate_champ_formulaire_pub("last_name", true, _x("Nom","personne", "MonLabo"), get_MonLabo_Members_fields_comments('last_name'),
        $member_information->last_name);

    // Page wordpress
    //---------------
    $options2 = get_option( 'MonLabo_settings_group2' );

    if($member_id != 0) {
        $retval.='<br />';
        if ((array_key_exists('MonLabo_perso_page_parent', $options2)) && (!empty($options2['MonLabo_perso_page_parent'])) ) {
          $wp_post_id_edited='';
          if (!is_numeric($member_information->wp_post_id)) {
              //Si wp_post_id a été édité
              $wp_post_id_edited=$member_information->wp_post_id;
              $member_information->wp_post_id=0;
          }
          $retval.=generate_champ_formulaire_select_page("wp_post_id", true, __("Page wordpress","MonLabo"), "", $member_information->wp_post_id, $options2['MonLabo_perso_page_parent']);
          $retval.= '<input id="edition_wp_post_id" class="button" value="'.__("Éditer l&apos;adresse de la page", "MonLabo").'" onclick="affiche_edition_wp_post_id();" type="button" />';
          $retval.= '<div id="edition_wp_post_id_field"> ';
          $retval.=generate_champ_formulaire_pub("edition_wp_post_id", false,__("Adresse spécifique.","MonLabo") , __("URL au format http://... ou https://... Plusieurs adresses peuvent être entrées en les séparant par une virgule.", "MonLabo"), $wp_post_id_edited);
          $retval.=generate_champ_formulaire_pub("alternate_image", false,__("URL de l&apos;image de la page","MonLabo") , " ", $member_information->alternate_image);
          $retval.='<input type="hidden" id="wp_post_id_post_link" value="'.get_permalink( $member_information->wp_post_id ).'" />';
          $retval.='<input type="hidden" id="wp_post_id_edited" value="'.$wp_post_id_edited.'" />';
          $retval.= '</div>';
          //
        } else {
          $retval.=MonLabo_admin::notice_message("error", __("Erreur :","MonLabo"),
                                                 __("La page de rattachement des pages personnelles est mal renseignée <a href=\"admin.php?page=MonLabo_config&tab=tab_appearance\">dans les configurations générales</a>.","MonLabo"));
        }
    }
    $retval.='</fieldset>';

    //photo
    //-----
    $retval.='<div class="alignleft" id="delayedLoadDivThumbnail"><!-- Nous allons afficher ici la suite en asynchone grâce à ajax. --></div>';

    // Propriété
    //---------
    $retval.='<fieldset class="clear"><legend>'.__("Propriétés :", "MonLabo").'</legend>';

    //Dans le cas où il n'y a qu'une unité, configurer si la personne en est ou pas le directeur
    $options0=get_option( 'MonLabo_settings_group0' );
    if (empty($options0['MonLabo_uses_unites']) ){
        $valueDirector=__("(co)directeur ou (co)directrice de l&apos;unité", "MonLabo");
        $directors_of_default_unit=$MonLabo_access_data->get_directors_id_for_an_unit(MAIN_STRUCT_NO_UNIT, $status="all");
        if (!empty($directors_of_default_unit) and (in_array($member_id, $directors_of_default_unit))) {
            $valeur_initiale_check_director=Array("0"=>$valueDirector);
            //$valeur_initiale_check_director=$valueDirector;
        } else {
            $valeur_initiale_check_director=null;
        }
        $retval.=generate_champ_formulaire_checkboxes("is_director", $values=Array(0=>$valueDirector), true, __("Direction ?", "MonLabo"), "", $valeur_initiale_check_director);
    }

    $retval.='<br />';
    $functions_by_category=$MonLabo_access_data->get_multilingual_functions_by_category();

    $member_information->category=mb_strtolower($member_information->category, 'UTF-8'); //On converti la catégorie en minuscule (pour une compatibilité avec les anciennes versions de MonLabo)
    $onchange = "touchCategoryNouvelAuteur(this.value)";
    $retval.=generate_champ_formulaire_select("category", get_MonLabo_persons_categories(), false, _x("Catégorie et fonction","personne","MonLabo"), get_MonLabo_Members_fields_comments('category'),
                                                $member_information->category, $onchange);
    $onchange = "touchFonctionNouvelAuteur(this.value)";
    $retval.=generate_champ_formulaire_select("fonction", $functions_by_category, false, "", get_MonLabo_Members_fields_comments('fonction'),
                                                $member_information->function_en.' | '.$member_information->function_fr, $onchange);
    $retval.= '<input id="edition_fonctions_button" class="button" value="'.__("Éditer / Nouveau", "MonLabo").'" onclick="affiche_edition_fonctions_fields();" type="button">';
    $retval.='<br /><div id="edition_fonctions_fields">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
    $retval.=generate_champ_formulaire_pub("function_en", true, _x("Nouvelle fonction (anglais)","personne","MonLabo"), get_MonLabo_Members_fields_comments('function_en'),
                                            $member_information->function_en);
    $retval.=generate_champ_formulaire_pub("function_fr", true, _x("Nouvelle fonction (français)","personne","MonLabo"), get_MonLabo_Members_fields_comments('function_fr'),
                                            $member_information->function_fr);
    $retval.='<br /></div>';
    $all_teams_name = $MonLabo_access_data->get_teams_name("fr");
    if ($member_id != 0) {
        $teams_name = $MonLabo_access_data->get_teams_name_for_a_person($member_information->id, "fr");
    } else {
        $teams_name = Array();
    }
    $retval.=generate_champ_formulaire_checkboxes("teams", $all_teams_name, true, __("Équipes","MonLabo"), get_MonLabo_Members_fields_comments('teams'),
    $teams_name);
    $retval.='<br />';
    //choix des tuteurs
    if ($member_id != 0) {
        $mentors_name = $MonLabo_access_data->get_mentors_name_for_a_person($member_information->id, $status="all");
    } else {
        $mentors_name = Array();
    }
    unset($members_name_actif[$member_information->id]);  // on ne peut pas être tuteur de soi-même
    unset($members_name_alumni[$member_information->id]); // même si on est alumni
    $values = Array("Actifs" => $members_name_actif , "Alumni" => $members_name_alumni);
    $retval.=generate_champ_formulaire_select_multiple("mentors", $values, false, __("Tuteur(s)","MonLabo"), get_MonLabo_Members_fields_comments('mentors'),
        $mentors_name);
    //choix des étudiants
    if ($member_id != 0) {
        $students_name = $MonLabo_access_data->get_students_name_for_a_person($member_information->id, $status="all");
    } else {
        $students_name = Array();
    }
    unset($members_name_actif[$member_information->id]); // on ne peut pas être étudiant de soi-même
    unset($members_name_alumni[$member_information->id]); // même si on est alumni
    $values = Array("Actifs" => $members_name_actif , "Alumni" => $members_name_alumni);
    $retval.=generate_champ_formulaire_select_multiple("students", $values, false, __("Etudiant(s)","MonLabo"), get_MonLabo_Members_fields_comments('students'),
        $students_name);


    // Coordonnées
    //------------
    $retval.='</fieldset><fieldset><legend>'._x('Coordonnées :',"personne","MonLabo").'</legend>';
    $retval.=generate_champ_formulaire_pub("mail", false, __("E-mail","MonLabo"), get_MonLabo_Members_fields_comments('mail'),
        $member_information->mail);
    $retval.=generate_champ_formulaire_pub("room", false, __("N° de porte","MonLabo"), get_MonLabo_Members_fields_comments('room'),
        $member_information->room);
    $retval.=generate_champ_formulaire_pub("external_url", false,__("Site perso ext.","MonLabo") , get_MonLabo_Members_fields_comments('external_url'),
        $member_information->external_url);
    $retval.=generate_champ_formulaire_pub("phone", false, __("Poste téléphonique","MonLabo"), get_MonLabo_Members_fields_comments('phone'),
        $member_information->phone);
    $retval.='<br />';
    $retval.=generate_champ_formulaire_pub("address_alt", false, __("Adresse alternative","MonLabo"), get_MonLabo_Members_fields_comments('address_alt'),
        $member_information->address_alt);

    // Liens externes
    //---------------
    $options0 = get_option('MonLabo_settings_group0');
    if ($options0["MonLabo_publication_server_type"] != "aucun") {
        $retval.='</fieldset><fieldset><legend>'.__('Publications :',"MonLabo").'</legend>';
        if ($options0["MonLabo_publication_server_type"]==="DescartesPubli") {
            $retval.=generate_champ_formulaire_pub("descartes_publi_author_id", false, __("ID d'auteur Descartes Publi","MonLabo"),
                get_MonLabo_Members_fields_comments('descartes_publi_author_id'), $member_information->descartes_publi_author_id);
        }
        if ($options0["MonLabo_publication_server_type"]==="hal") {
            $retval.=generate_champ_formulaire_pub("hal_publi_author_id", false, __("ID d'auteur HAL","MonLabo"),
                get_MonLabo_Members_fields_comments('hal_publi_author_id'), $member_information->hal_publi_author_id );
        }
        $retval.='<br />';
    }
    /*if  ($options0["MonLabo_publication_server_type"]==="DescartesPubli") {
        $retval.=generate_champ_formulaire_pub("uid_ENT_parisdescartes", false,__("Identifiant ENT Paris Descartes","MonLabo"),
            get_MonLabo_Members_fields_comments('uid_ENT_parisdescartes'), $member_information->uid_ENT_parisdescartes);
    }*/

    // Etat
    //------------
        $retval.='</fieldset><fieldset><legend>'._x('États :',"personne","MonLabo").'</legend>';
    $retval.=generate_champ_formulaire_select("status", Array("actif"=>__("actif","MonLabo"),"alumni"=>__("alumni","MonLabo")), false,_x("Statut", "personne","MonLabo"),
        get_MonLabo_Members_fields_comments('status'), $member_information->status);

    $retval.="<div id='MonLabo_dateDepartureForm'>".generate_champ_formulaire_pub("date_departure", false, __("Date depart de l&apos;unité","MonLabo"), get_MonLabo_Members_fields_comments('date_departure'),
                                            $member_information->date_departure)."</div>";
    $retval.='<br />';
    $retval.=generate_champ_formulaire_select("visible", Array("oui"=>__("oui","MonLabo"),"non"=>__("non","MonLabo")), false,__("Personnel visible ?","MonLabo"),
        get_MonLabo_Members_fields_comments('visible'), $member_information->visible);
    $retval.='</fieldset>';

    $options = get_option('MonLabo_settings_group0');
    if (isset($options0["MonLabo_uses_custom_fields_for_staff"]) && (intval($options0["MonLabo_uses_custom_fields_for_staff"])===1)) {
        $retval.='</fieldset><fieldset><legend>'.__("Champs personnalisés :","MonLabo").'</legend>';
        $options3 = get_option('MonLabo_settings_group3');
        if ($options3["MonLabo_custom_fields_number"]<"1") { $nb=0; }
        elseif ($options3["MonLabo_custom_fields_number"]>"10") { $nb=10;}
        else { $nb=intval($options3["MonLabo_custom_fields_number"]); }
        for ($i=1; $i <= $nb; $i++) {
            $nom_variable = "custom".$i;
            $retval.=generate_champ_formulaire_pub($nom_variable, false, $nom_variable,
                                        "custom_".$options3["MonLabo_custom_field".$i."_title"], $member_information->$nom_variable);
        }
        $retval.='</fieldset>';
    }
    $onclick = "edit_member()";
    if ($valeur_initiale != $nouveau_membre_string) {
        $retval.=generate_submit_button(__("Modifier","MonLabo"), "submit_modify_member", $onclick);
    } else {
        $retval.=generate_submit_button(__("Créer","MonLabo"), "submit_new_member", $onclick);
    }
    if ($valeur_initiale != $nouveau_membre_string) {
        $onclick = "remove_member()";
        $retval.=generate_submit_button(__("Supprimer","MonLabo"), "submit_delete_member", $onclick);
    }
    $retval.='</div></form>';
    return $retval;
}

function edit_teams_form() {
    require_once( dirname(__FILE__) . '/includes/inc-lib-forms.php' );

    $options0 = get_option('MonLabo_settings_group0');
    $MonLabo_access_data = New MonLabo_access_data();

    list($retval, $team_id, $team_id_if_created)=form_edit_team_processing();

    $myurl = admin_url('admin.php?page=MonLabo_edit_members_and_groups&tab=tab_two');

    $nouvelle_equipe_string='&mdash; '.__("Nouvelle équipe", "MonLabo" ).' &mdash;';
    $teams_name = $MonLabo_access_data->get_teams_name("fr");
    $teams_name = array("0" => $nouvelle_equipe_string) + $teams_name;


    //Get team infomation. If invalid of new, return an empty object
    if ($team_id != 0) {
        $team_information = $MonLabo_access_data->get_team_information($team_id);
        //If invalid ID
        if ($team_information==NULL) {
            $team_id=0;
        }
    }
    if ($team_id==0) {
        $team_information = (object) Array("id"=>0, "name_en"=>"", "name_fr"=>""
                , "wp_post_id"=>"", "external_url"=>"", "descartes_publi_team_id"=>"", "hal_publi_team_id"=>""
                , "logo"=>"", "color"=>"");
    }
    $valeur_initiale = $teams_name[$team_id];

    // formulaire choix de l'équipe à éditer
    $name = "item";
    $values = $teams_name;
    $isMandatory = false;
    $legend = __("Équipe", "MonLabo");
    $description = "";
    $onchange="change_team(this.value)";
    $retval.='<form class="navbar-form" id="choix_equipe" method="post" action="'.$myurl.'">
    <div class="form-group">';
    $retval.='<fieldset><legend>'.__("Sélection :", "MonLabo" ).'</legend>';
    $retval.=generate_champ_formulaire_select($name, $values, $isMandatory, $legend, $description, $valeur_initiale, $onchange);
    $retval.='</fieldset>';
    $retval.='</form>';
    $retval.='<hr/>';

    // formulaire d'édition de l'équipe
    $retval.='<form class="navbar-form" id="form_edit_team" accept-charset="utf-8" method="post"
            enctype="multipart/form-data" action="'.$myurl.'&submit_item='.$team_id.'">
            <div class="form-group">';
    $retval.='<fieldset><legend>'.__('Informations :', "MonLabo").'</legend>';
    $retval.='<input type="hidden" name="submit_id" value="'.$team_id.'">';
    $retval.='<input type="hidden" name="action" id="action" value="">';
    if ($team_id != 0) {
        $retval.="Id : ".$team_information->id."<br />";
    }
    $retval.=generate_champ_formulaire_pub("name_fr", true, __("Nom français","MonLabo"), get_MonLabo_Team_fields_comments('name_fr'),
        $team_information->name_fr);
    $retval.=generate_champ_formulaire_pub("name_en", true, __("Nom anglais","MonLabo"), get_MonLabo_Team_fields_comments('name_en'),
        $team_information->name_en);
    $retval.='<br />';
    $retval.=generate_champ_formulaire_pub("wp_post_id", false, __("Pages ID","MonLabo"),
        get_MonLabo_Team_fields_comments('wp_post_id'), $team_information->wp_post_id);
    $retval.='<br />';
    $retval.=generate_champ_formulaire_pub("external_url", false, __("URL externe","MonLabo"),
        get_MonLabo_Team_fields_comments('external_url'), $team_information->external_url);
    $retval.='<br />';

    $members_name_actif = $MonLabo_access_data->get_persons_name_for_a_team($team_id, $status="actif");
    $members_name_alumni = $MonLabo_access_data->get_persons_name_for_a_team($team_id, $status="alumni");
    if ($members_name_actif == null) {
        $members_name_actif = $MonLabo_access_data->get_persons_name($status="actif");
        $members_name_alumni = $MonLabo_access_data->get_persons_name($status="alumni");
    }
    $values = Array("Actifs" => $members_name_actif , "Alumni" => $members_name_alumni);
    $leaders_name = $MonLabo_access_data->get_leaders_name_for_a_team($team_id,$status="all");
    $retval.=generate_champ_formulaire_select_multiple("leaders", $values, false, __("Chefs d&apos;équipe","MonLabo"), get_MonLabo_Team_fields_comments('leaders'), $leaders_name);
    $retval.='</fieldset>';

    $retval.='<fieldset><legend>'.__('Apparence :', "MonLabo").'</legend>';
    $retval.=generate_champ_formulaire_pub("logo", false, __("Logo","MonLabo"), get_MonLabo_Team_fields_comments('logo'), $team_information->logo);

    //couleurs
    //$retval.="<br />";
    $retval.='<div class="input-group"><label for="">'.__('Couleur', "MonLabo").' : </label>';
    $retval.=generate_champ_formulaire_pub("color", false, __("Couleur","MonLabo"), get_MonLabo_Team_fields_comments('color'), $team_information->color);
    $retval.='</fieldset>';

    $retval.='<fieldset><legend>'.__('Appartenance :', "MonLabo").'</legend>';
    $units_name=array();
    if (isset($options0["MonLabo_uses_unites"]) && (intval($options0["MonLabo_uses_unites"])===1)) { //On n'affiche cette option que si l'on gère les unités
        $units_name = $MonLabo_access_data->get_units_name("fr");
        if(!empty($units_name)){
            foreach ($units_name as $unit_id => $unit_name) {
                $units_name[$unit_id]=__("Unité","MonLabo")." ".$unit_id." : ".$unit_name;
            }
        }
    }
    $units_name[MAIN_STRUCT_NO_UNIT]=__("Structure principale","MonLabo");
    if((property_exists($team_information,"id_unit")) and (array_key_exists($team_information->id_unit, $units_name))) {
        $id_unit_valeur_initiale=$team_information->id_unit;
    } else {
        $id_unit_valeur_initiale=MAIN_STRUCT_NO_UNIT;
    }
    $retval.=generate_champ_formulaire_radio("id_unit", $units_name, true, __("Structure","MonLabo"), get_MonLabo_Team_fields_comments('id_unit'), $units_name[$id_unit_valeur_initiale]);
    if (isset($options0["MonLabo_uses_thematiques"]) && (intval($options0["MonLabo_uses_thematiques"])===1)) { //On n'affiche cette option que si l'on gère les thématiques
        $all_thematics_name = $MonLabo_access_data->get_thematics_name("fr");
        $thematics_name = $MonLabo_access_data->get_thematics_name_for_a_team($team_id, "fr");
        $retval.=generate_champ_formulaire_select_multiple("thematics", $all_thematics_name, false,  MonLaboLib::get_teamGroupName_pl(),
            get_MonLabo_Team_fields_comments('thematics'), $thematics_name);
    }
    $retval.='</fieldset>';
    if ($options0["MonLabo_publication_server_type"]!="aucun") {
        $retval.='<fieldset><legend>'.__('Publications :', "MonLabo").'</legend>';
        if ($options0["MonLabo_publication_server_type"]==="DescartesPubli") {
            $retval.=generate_champ_formulaire_pub("descartes_publi_team_id", false, __("ID Descartes Publi de l&apos;équipe","MonLabo"),
            get_MonLabo_Team_fields_comments('descartes_publi_team_id'), $team_information->descartes_publi_team_id);
        }
        if ($options0["MonLabo_publication_server_type"]==="hal") {
            $retval.=generate_champ_formulaire_pub("hal_publi_team_id", false, __("ID HAL de l&apos;équipe","MonLabo"),
            get_MonLabo_Team_fields_comments('hal_publi_team_id'), $team_information->hal_publi_team_id);
        }
        $retval.='</fieldset>';
    }
    $onclick = "edit_team()";
    if ($valeur_initiale != $nouvelle_equipe_string) {
        $retval.=generate_submit_button( __("Modifier","MonLabo"), "submit_edit_team", $onclick);
    } else {
        $retval.=generate_submit_button( __("Créer","MonLabo"), "submit_new_team", $onclick);
    }
    if ($valeur_initiale != $nouvelle_equipe_string) {
        $onclick = "remove_team()";
        $retval.=generate_submit_button( __("Supprimer","MonLabo"), "submit_delete_team", $onclick);
    }
    $retval.='</div></form>';
    return $retval;
}

function edit_thematics_form(){
    $options0 = get_option('MonLabo_settings_group0');
    require_once( dirname(__FILE__) . '/includes/inc-lib-forms.php' );
    $MonLabo_access_data = New MonLabo_access_data();

    list($retval, $thematic_id, $thematic_id_if_created)=form_edit_thematic_processing();

    $myurl = admin_url('admin.php?page=MonLabo_edit_members_and_groups&tab=tab_three');

    $thematics_name = $MonLabo_access_data->get_thematics_name("fr");
    $nouvelle_thematique_string='&mdash; '.__("Nouvelle thématique", "MonLabo" ).' &mdash;';
    $thematics_name = array("0" => $nouvelle_thematique_string) + $thematics_name;

    //Get thematic information. If invalid of new, return an empty object
    if ($thematic_id != 0) {
        $thematic_information = $MonLabo_access_data->get_thematic_information($thematic_id);
        //If invalid ID
        if ($thematic_information==NULL) {
            $thematic_id=0;
        }
    }
    if ($thematic_id==0) {
        $thematic_information = (object) Array("id"=>0, "name_en"=>"", "name_fr"=>"", "wp_post_id" => ""
                , "logo"=>"", "external_url"=>"", "hal_publi_thematic_id"=>"");
    }
    $valeur_initiale = $thematics_name[$thematic_id];

    // formulaire choix de la thematique à éditer
    $name = "item";
    $values = $thematics_name;
    $isMandatory = false;

    $legend =  MonLaboLib::get_teamGroupName_pl();
    $description = "";
    $onchange="change_thematic(this.value)";

    $retval.='  <form class="navbar-form" id="choix_thematique" method="post" action="'.$myurl.'">
            <div class="form-group">';
    $retval.='<fieldset><legend>'.__("Sélection :","MonLabo").'</legend>';
    $retval.=generate_champ_formulaire_select($name, $values, $isMandatory, $legend, $description, $valeur_initiale, $onchange);
    $retval.='</fieldset></div>';
    $retval.='</form>';
    $retval.='<hr/>';

    // formulaire d'édition de la thématique
    $retval.='  <form class="navbar-form" id="form_edit_thematic" accept-charset="utf-8" method="post"
            enctype="multipart/form-data" action="'.$myurl.'&submit_item='.$thematic_id.'">
            <div class="form-group">';
    $retval.='<fieldset><legend>'.__('Informations :', "MonLabo").'</legend>';
    $retval.='<input type="hidden" name="submit_id" value="'.$thematic_id.'">';
    $retval.='<input type="hidden" name="action" id="action" value="">';
    if ($thematic_id != 0) {
        $retval.="Id : ".$thematic_information->id."<br />";
    }
    $retval.=generate_champ_formulaire_pub("name_fr", true, __("Nom français","MonLabo"), get_MonLabo_Thematic_fields_comments('name_fr'),
        $thematic_information->name_fr);
    $retval.=generate_champ_formulaire_pub("name_en", true, __("Nom anglais","MonLabo"), get_MonLabo_Thematic_fields_comments('name_en'),
        $thematic_information->name_en);
    $retval.='<br />';
    $retval.=generate_champ_formulaire_pub("wp_post_id", false, __("Pages ID","MonLabo"),
        get_MonLabo_Thematic_fields_comments('wp_post_id'), $thematic_information->wp_post_id);
        $retval.='<br />';
    $retval.=generate_champ_formulaire_pub("external_url", false, __("URL","MonLabo"), get_MonLabo_Thematic_fields_comments('external_url'),
        $thematic_information->external_url);

    $retval.='</fieldset>';
    $retval.='<fieldset><legend>'.__('Apparence :', "MonLabo").'</legend>';
    $retval.=generate_champ_formulaire_pub("logo", false, __("Logo","MonLabo"), get_MonLabo_Thematic_fields_comments('logo'),
        $thematic_information->logo);

    $retval.='</fieldset>';
    $onclick = "edit_thematic()";
    if ($valeur_initiale != $nouvelle_thematique_string) {
        $retval.=generate_submit_button( __("Modifier", "MonLabo"), "submit_modify_thematic", $onclick);
    } else {
        $retval.=generate_submit_button( __("Créer", "MonLabo"), "submit_new_thematic", $onclick);
    }
    if ($valeur_initiale != $nouvelle_thematique_string) {
        $onclick = "remove_thematic()";
        $retval.=generate_submit_button( __("Supprimer", "MonLabo"), "submit_delete_thematic", $onclick);
    }
    $retval.='</div></form>';
    return $retval;
}

function edit_unites_form(){
    require_once( dirname(__FILE__) . '/includes/inc-lib-forms.php' );
    $MonLabo_access_data = New MonLabo_access_data();

    list($retval, $unit_id, $unit_id_if_created)=form_edit_unite_processing();
    $myurl=admin_url('admin.php?page=MonLabo_edit_members_and_groups&tab=tab_four');
    $nouvelle_unite_string='&mdash; '.__("Nouvelle unité", "MonLabo" ).' &mdash;';

    $units_name = $MonLabo_access_data->get_units_name("fr");
    $units_name = array("0" => $nouvelle_unite_string) + $units_name;

    //Get unit information. If invalid of new, return an empty object
    if ($unit_id != 0) {
        $unit_information = $MonLabo_access_data->get_unit_information($unit_id);
        //If invalid ID
        if ($unit_information==NULL) {
            $unit_id=0;
        }
    }
    if ($unit_id==0) {
        $unit_information = (object) Array("id"=>0, "code"=>"", "affiliations"=>""
                , "name_en"=>"", "name_fr"=>"", "wp_post_id" => ""
                , "external_url"=>"", "descartes_publi_unit_id"=>"", "hal_publi_unit_id"=>"", "logo"=>"", "address_alt"=>"", "contact_alt"=>"");
    }
    $valeur_initiale = $units_name[$unit_id];

    // formulaire choix de la thematique à éditer
    $name = "item";
    $values = $units_name;
    $isMandatory = false;
    $legend = __("Unité", "MonLabo");
    $description = "";
    $onchange="change_unite(this.value)";
    $retval.='<form class="navbar-form" id="choix_unite" method="post" action="'.$myurl.'"><div class="form-group">';
    $retval.='<fieldset><legend>'.__("Sélection :", "MonLabo" ).'</legend>';
    $retval.=generate_champ_formulaire_select($name, $values, $isMandatory, $legend, $description, $valeur_initiale, $onchange);
    $retval.='</fieldset>';
    $retval.='</div></form>';
    $retval.='<hr/>';

    // formulaire d'édition de l'unité
    $retval.='  <form class="navbar-form" id="form_edit_unite" accept-charset="utf-8" method="post" enctype="multipart/form-data" action="'.$myurl.'&submit_item='.$unit_id.'"><div class="form-group">';
    $retval.='<fieldset><legend>'.__('Informations :', "MonLabo").'</legend>';
    $retval.='<input type="hidden" name="submit_id" value="'.$unit_id.'">';
    $retval.='<input type="hidden" name="action" id="action" value="">';
    if ($unit_id != 0) {
        $retval.="Id : ".$unit_information->id."<br />";
    }
    $retval.=generate_champ_formulaire_pub("affiliations", true, "Affiliations",
    get_MonLabo_Unite_fields_comments('affiliations'), $unit_information->affiliations);
    $retval.='<br />';
    $retval.=generate_champ_formulaire_pub("code", true, _x("Code", "unité", "MonLabo"), get_MonLabo_Unite_fields_comments('code'),
    $unit_information->code);
    $retval.='<br />';
    $retval.=generate_champ_formulaire_pub("name_fr", true, __("Nom français", "MonLabo"), get_MonLabo_Unite_fields_comments('name_fr'),
    $unit_information->name_fr);
    $retval.=generate_champ_formulaire_pub("name_en", true, __("Nom anglais", "MonLabo"), get_MonLabo_Unite_fields_comments('name_en'),
    $unit_information->name_en);
    $retval.='<br />';
    //$members_name = $MonLabo_access_data->get_persons_name($status="all");
    $members_name_actif = $MonLabo_access_data->get_persons_name($status="actif");
    $members_name_alumni = $MonLabo_access_data->get_persons_name($status="alumni");
    $values = Array("Actifs" => $members_name_actif , "Alumni" => $members_name_alumni);

    $directors_name = $MonLabo_access_data->get_directors_name_for_an_unit($unit_id, $status="all");
    $retval.=generate_champ_formulaire_select_multiple("directors", $values, false, __("Directeurs", "MonLabo"),
        get_MonLabo_Unite_fields_comments('directors'), $directors_name);
    $retval.='<br />';
    $retval.=generate_champ_formulaire_pub("wp_post_id", false, __("Pages ID","MonLabo"),
        get_MonLabo_Unite_fields_comments('wp_post_id'), $unit_information->wp_post_id);
    $retval.='<br />';
    $retval.=generate_champ_formulaire_pub("external_url", false, __("URL", "MonLabo"), get_MonLabo_Unite_fields_comments('external_url'),
        $unit_information->external_url);

    $retval.='</fieldset>';
    $retval.='<fieldset><legend>'.__('Apparence :', "MonLabo").'</legend>';
    $retval.=generate_champ_formulaire_pub("logo", false, __("Logo","MonLabo"), get_MonLabo_Unite_fields_comments('logo'),
        $unit_information->logo);
    $retval.='</fieldset>';

    $options0 = get_option('MonLabo_settings_group0');
    if ($options0["MonLabo_publication_server_type"]!="aucun") {
        $retval.='<fieldset><legend>'.__('Publications :', "MonLabo").'</legend>';
        if ($options0["MonLabo_publication_server_type"]==="DescartesPubli") {
            $retval.=generate_champ_formulaire_pub("descartes_publi_unit_id", false, __("ID Descartes Publi de l&apos;unité","MonLabo"),
            get_MonLabo_Unite_fields_comments('descartes_publi_unit_id'), $unit_information->descartes_publi_unit_id);
        }
        if ($options0["MonLabo_publication_server_type"]==="hal") {
            $retval.=generate_champ_formulaire_pub("hal_publi_unit_id", false, __("ID HAL de l&apos;unité","MonLabo"),
            get_MonLabo_Unite_fields_comments('hal_publi_unit_id'), $unit_information->hal_publi_unit_id);
        }
        $retval.='</fieldset>';
    }
    $retval.='<fieldset><legend>'.__('Coordonnées alternatives (si différentes de la structure principale) :', "MonLabo").'</legend>';
    $retval.=generate_champ_formulaire_pub("address_alt", false, __("Adresse alternative","MonLabo"), get_MonLabo_Unite_fields_comments('address_alt'),
        $unit_information->address_alt);
    $retval.=generate_champ_formulaire_pub("contact_alt", false, __("Contact alternatif","MonLabo"), get_MonLabo_Unite_fields_comments('contact_alt'),
        $unit_information->contact_alt);

    $retval.='</fieldset>';
    $onclick = "edit_unite()";
    if ($valeur_initiale != $nouvelle_unite_string) {
        $retval.=generate_submit_button( __("Modifier", "MonLabo"), "submit_edit_unite", $onclick);
    } else {
        $retval.=generate_submit_button( __("Créer", "MonLabo"), "submit_new_unite", $onclick);
    }
    if ($valeur_initiale != $nouvelle_unite_string) {
        $onclick = "remove_unite()";
        $retval.=generate_submit_button( __("Supprimer", "MonLabo"), "submit_delete_unite", $onclick);
    }
    $retval.='</div></form>';
    return $retval;
}

function edit_structure_principale_form(){
    require_once( dirname(__FILE__) . '/includes/inc-lib-forms.php' );
    $retval=form_edit_structure_principale_processing();

    $MonLabo_access_data = New MonLabo_access_data();
    $options0=get_option( 'MonLabo_settings_group0' );
    $options1=get_option( 'MonLabo_settings_group1' );

    $myurl=admin_url('admin.php?page=MonLabo_edit_members_and_groups&tab=tab_five');

    $retval.='  <form class="navbar-form" id="form_edit_structure_principale" accept-charset="utf-8" method="post"
            enctype="multipart/form-data" action="'.$myurl.'">
            <div class="form-group">';
    if (isset($options0["MonLabo_uses_unites"]) && (intval($options0["MonLabo_uses_unites"])===1)) {
        $retval.='<fieldset><legend>'.__('Coordonnées de la structure rassemblant les laboratoires :', "MonLabo").'</legend>';
    } else {
        $retval.='<fieldset><legend>'.__('Coordonnées :', "MonLabo").'</legend>';
    }
    //Si $options1["truc"] n'existe pas, y mettre une valeur par défaut
    $default_options=get_options_DEFAULT();
    foreach ($default_options["MonLabo_settings_group1"] as $option_name => $option_value) {
        if (!isset($options1[$option_name])) {
            $options1[$option_name]="$option_value";
        }
    }

    $retval.=generate_champ_formulaire_pub("nom", true, "Nom de la structure",
        get_MonLabo_Structure_principale_fields_comments('nom'), $options1["MonLabo_nom"]);
    $retval.=generate_champ_formulaire_pub("code", true, "Code de la structure",
        get_MonLabo_Structure_principale_fields_comments('code'), $options1["MonLabo_code"]);
    $retval.="<br />".generate_champ_formulaire_pub("adresse", true, "Adresse de la structure",
        get_MonLabo_Structure_principale_fields_comments('adresse'), $options1["MonLabo_adresse"]);
    $retval.="<br />".generate_champ_formulaire_pub("prefixe_tel", false, "Préfixe téléphonique",
        get_MonLabo_Structure_principale_fields_comments('prefixe_tel'), $options1["MonLabo_prefixe_tel"]);
    $retval.="<br />".generate_champ_formulaire_pub("contact", false, "Mail, tel, fax ou contact",
        get_MonLabo_Structure_principale_fields_comments('contact'), $options1["MonLabo_contact"]);
    $retval.='</fieldset>';
    if ($options0["MonLabo_publication_server_type"]==="hal") {
        $retval.='<fieldset><legend>'.__('Publications :', "MonLabo").'</legend>';
        $retval.="<br />".generate_champ_formulaire_pub("hal_publi_struct_id", false, "ID HAL",
            get_MonLabo_Structure_principale_fields_comments('hal_publi_struct_id'), $options1["MonLabo_hal_publi_struct_id"]);
        $retval.='</fieldset>';
    } else {
    }
    $retval.='<fieldset><legend>'.__('Direction :', "MonLabo").'</legend>';
    $members_name_actif = $MonLabo_access_data->get_persons_name($status="actif");
    $members_name_alumni = $MonLabo_access_data->get_persons_name($status="alumni");
    $values = Array("Actifs" => $members_name_actif , "Alumni" => $members_name_alumni);
    $directors_name = $MonLabo_access_data->get_directors_name_for_an_unit(MAIN_STRUCT_NO_UNIT, $status="all");
    $retval.=generate_champ_formulaire_select_multiple("directors", $values, false, __("Directeurs", "MonLabo"),
        get_MonLabo_Structure_principale_fields_comments('directors'), $directors_name);
    $retval.='<br />';
    $retval.='</fieldset>';
    $retval.=generate_submit_button( __("Modifier", "MonLabo"), "submit_edit_structure_principale", "");
    $retval.='</div></form>';
    return $retval;
}

function  display_advanced_features_for_mmebers(){
    require_once( dirname(__FILE__) . '/includes/inc-lib-forms.php' );
    $retval=form_advanced_features_for_members_processing();
    $myurl=admin_url('admin.php?page=MonLabo_edit_members_and_groups&tab=tab_seven');

    $MonLabo_access_data = New MonLabo_access_data();
    $options2=get_option( 'MonLabo_settings_group2' );
    $retval.='  <form class="navbar-form" id="form_creer_pages_manquantes" accept-charset="utf-8" method="post"
            enctype="multipart/form-data" action="'.$myurl.'">
            <div class="form-group">';

    $retval.='<h3 id="pages_manquantes">'.__('Créer les pages manquantes', "MonLabo").'</h3>';
    $retval.="<p>Cet outil peut être utile pour ceux qui auraient importé une base de personnels directement dans la base de donnée de MonLabo. Il est alors nécessaire de créer les pages Wordpress de chaque membre.</p>";
    $options2 = get_option( 'MonLabo_settings_group2' );

    if ((array_key_exists('MonLabo_perso_page_parent', $options2)) && (!empty($options2['MonLabo_perso_page_parent'])) ) {
        $members_name_actif = $MonLabo_access_data->get_persons_information($status="actif");
        $members_without_wp_post_id = array();
        if(!empty($members_name_actif)) {
            foreach ($members_name_actif as $id => $member) {
                if (empty($member->wp_post_id)) {
                    $members_without_wp_post_id[$id]=$member;
                }
            }
        }
        if(!empty($members_without_wp_post_id)) {
            $retval.='<input type="hidden" name="create_missing_pages_submit_ids" value="'.serialize(array_keys($members_without_wp_post_id)).'">';
        }
        $retval.=generate_submit_button( __("Créer les pages manquantes", "MonLabo")." (".count($members_without_wp_post_id).")", "submit_creer_pages_manquantes", "");
        $retval.='<p>'.__('Les personnels suivants n\'ont pas encore de page WordPress', "MonLabo").' : ';
        if(!empty($members_without_wp_post_id)) {
            foreach ($members_without_wp_post_id as $id => $member) {
                $retval.='<em>'.$member->first_name.' '.$member->last_name.'</em>, ';
            }
        }
    } else {
      $retval.=MonLabo_admin::notice_message("error", __("Erreur :","MonLabo"),
                                             __("La page de rattachement des pages personnelles est mal renseignée <a href=\"admin.php?page=MonLabo_config&tab=tab_appearance\">dans les configurations générales</a>.","MonLabo"));
    }
    $retval.='<p></div>';
    $retval.='</form>';
    return $retval;
}
?>
