-- phpMyAdmin SQL Dump
-- version 4.5.4.1deb2ubuntu2
-- http://www.phpmyadmin.net
--
-- Host: localhost
-- Generation Time: Jul 19, 2016 at 02:33 PM
-- Server version: 5.7.12-0ubuntu1.1
-- PHP Version: 7.0.4-7ubuntu2.1

SET SQL_MODE = "NO_AUTO_VALUE_ON_ZERO";
SET time_zone = "+00:00";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8mb4 */;

--
-- Database: `MonLabo`
--

-- --------------------------------------------------------

--
-- Table structure for table `MonLabo_mentors`
--

CREATE TABLE IF NOT EXISTS `MonLabo_mentors` (
  `id_person_supervisor` int(11) UNSIGNED NOT NULL,
  `id_person_student` int(11) UNSIGNED NOT NULL,
  PRIMARY KEY (`id_person_supervisor`,`id_person_student`),
  KEY `id_person_student` (`id_person_student`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- --------------------------------------------------------

--
-- Table structure for table `MonLabo_persons`
--

CREATE TABLE IF NOT EXISTS `MonLabo_persons` (
  `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
  `wp_post_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `title` varchar(20) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `first_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `last_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `category` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `function_fr` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `function_en` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `mail` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `phone` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `room` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `address_alt` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `external_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `descartes_publi_author_id` int(11) DEFAULT NULL,
  `hal_publi_author_id` int(11) DEFAULT NULL,
  `uid_ENT_parisdescartes` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `date_departure` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `status` varchar(20) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT 'actif',
  `visible` varchar(3) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT 'oui',
  `custom1` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `custom2` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `custom3` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `custom4` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `custom5` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `custom6` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `custom7` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `custom8` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `custom9` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `custom10` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `alternate_image` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `MonLabo_teams`
--

CREATE TABLE IF NOT EXISTS `MonLabo_teams` (
  `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
  `name_fr` varchar(255) DEFAULT NULL,
  `name_en` varchar(255) DEFAULT NULL,
  `wp_post_id` varchar(255) DEFAULT NULL,
  `external_url` varchar(255) DEFAULT NULL,
  `descartes_publi_team_id` int(11) DEFAULT NULL,
  `hal_publi_team_id` int(11) DEFAULT NULL,
  `id_unit` int(5) DEFAULT NULL,
  `logo` varchar(255) DEFAULT NULL,
  `color` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `MonLabo_teams_members`
--

CREATE TABLE IF NOT EXISTS `MonLabo_teams_members` (
  `id_person` int(11) UNSIGNED NOT NULL,
  `id_team` int(11) UNSIGNED NOT NULL,
  `directing` tinyint(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id_person`,`id_team`),
  KEY `id_team` (`id_team`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- --------------------------------------------------------

--
-- Table structure for table `MonLabo_teams_thematics`
--

CREATE TABLE IF NOT EXISTS `MonLabo_teams_thematics` (
  `id_team` int(11) UNSIGNED NOT NULL,
  `id_thematic` int(11) UNSIGNED NOT NULL,
  PRIMARY KEY (`id_team`,`id_thematic`),
  KEY `id_thematic` (`id_thematic`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

-- --------------------------------------------------------

--
-- Table structure for table `MonLabo_thematics`
--

CREATE TABLE IF NOT EXISTS `MonLabo_thematics` (
  `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
  `name_fr` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `name_en` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `wp_post_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `logo` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `external_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `hal_publi_thematic_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `MonLabo_units`
--

CREATE TABLE IF NOT EXISTS `MonLabo_units` (
  `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
  `affiliations` varchar(200) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `code` varchar(50) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `name_fr` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `name_en` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `wp_post_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `address_alt` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `contact_alt` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `external_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `descartes_publi_unit_id` int(11) DEFAULT NULL,
  `hal_publi_unit_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  `logo` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
  PRIMARY KEY (`id`),
  UNIQUE KEY `id` (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- --------------------------------------------------------

--
-- Table structure for table `MonLabo_units_directors`
--

CREATE TABLE IF NOT EXISTS `MonLabo_units_directors` (
  `id_person` int(11) UNSIGNED NOT NULL,
  `id_unit` int(11) UNSIGNED NOT NULL,
  PRIMARY KEY (`id_person`,`id_unit`),
  KEY `id_unit` (`id_unit`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;

--
-- Constraints for dumped tables
--

--
-- Constraints for table `MonLabo_mentors`
--
-- ALTER TABLE `MonLabo_mentors`
--  ADD CONSTRAINT `MonLabo_mentors_ibfk_1` FOREIGN KEY (`id_person_student`) REFERENCES `MonLabo_persons` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
--  ADD CONSTRAINT `MonLabo_mentors_ibfk_2` FOREIGN KEY (`id_person_supervisor`) REFERENCES `MonLabo_persons` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `MonLabo_teams_members`
--
-- ALTER TABLE `MonLabo_teams_members`
--  ADD CONSTRAINT `MonLabo_teams_members_ibfk_1` FOREIGN KEY (`id_team`) REFERENCES `MonLabo_teams` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
--  ADD CONSTRAINT `MonLabo_teams_members_ibfk_2` FOREIGN KEY (`id_person`) REFERENCES `MonLabo_persons` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `MonLabo_teams_thematics`
--
-- ALTER TABLE `MonLabo_teams_thematics`
--  ADD CONSTRAINT `MonLabo_teams_thematics_ibfk_1` FOREIGN KEY (`id_team`) REFERENCES `MonLabo_teams` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
--  ADD CONSTRAINT `MonLabo_teams_thematics_ibfk_2` FOREIGN KEY (`id_thematic`) REFERENCES `MonLabo_thematics` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

--
-- Constraints for table `MonLabo_units_directors`
--
-- ALTER TABLE `MonLabo_units_directors`
--  ADD CONSTRAINT `MonLabo_units_directors_ibfk_1` FOREIGN KEY (`id_unit`) REFERENCES `MonLabo_units` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
--  ADD CONSTRAINT `MonLabo_units_directors_ibfk_2` FOREIGN KEY (`id_person`) REFERENCES `MonLabo_persons` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;

/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
