<?php
if (!defined('WP_PLUGIN_DIR')) exit('No direct script access allowed');

require_once( dirname(__FILE__) . '/constants.php' );

class MonLabo_db {

    //private $db;

    function  __construct() {
        //Initialise $db si pas encore fait
        //if ($wpdb===NULL) {
        //    global $wpdb;
        //    $db = $wpdb;
        //}
    }

    public function  create_tables() {
        global $wpdb;

        $result = $wpdb->get_results( "CREATE TABLE IF NOT EXISTS `MonLabo_persons` (
              `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
              `wp_post_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `title` varchar(20) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `first_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `last_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `category` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `function_fr` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `function_en` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `mail` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `phone` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `room` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `address_alt` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `external_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `descartes_publi_author_id` int(11) DEFAULT NULL,
              `hal_publi_author_id` varchar(255) DEFAULT NULL,
              `uid_ENT_parisdescartes` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `date_departure` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `status` varchar(20) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT 'actif',
              `visible` varchar(3) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT 'oui',
              `custom1` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `custom2` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `custom3` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `custom4` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `custom5` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `custom6` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `custom7` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `custom8` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `custom9` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `custom10` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `alternate_image` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              PRIMARY KEY (`id`),
              UNIQUE KEY `id` (`id`)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
            ");
        $result = $wpdb->get_results( "CREATE TABLE IF NOT EXISTS `MonLabo_teams` (
              `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
              `name_fr` varchar(255) DEFAULT NULL,
              `name_en` varchar(255) DEFAULT NULL,
              `wp_post_id` varchar(255) DEFAULT NULL,
              `external_url` varchar(255) DEFAULT NULL,
              `descartes_publi_team_id` int(11) DEFAULT NULL,
              `hal_publi_team_id` varchar(255) DEFAULT NULL,
              `id_unit` int(5) DEFAULT NULL,
              `logo` varchar(255) DEFAULT NULL,
              `color` varchar(255) DEFAULT NULL,
              PRIMARY KEY (`id`)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
            ");
        $result = $wpdb->get_results( "CREATE TABLE IF NOT EXISTS `MonLabo_teams_members` (
              `id_person` int(11) UNSIGNED NOT NULL,
              `id_team` int(11) UNSIGNED NOT NULL,
              `directing` tinyint(1) NOT NULL DEFAULT '0',
              PRIMARY KEY (`id_person`,`id_team`),
              KEY `id_team` (`id_team`)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
            ");
        $result = $wpdb->get_results( "CREATE TABLE IF NOT EXISTS `MonLabo_teams_thematics` (
              `id_team` int(11) UNSIGNED NOT NULL,
              `id_thematic` int(11) UNSIGNED NOT NULL,
              PRIMARY KEY (`id_team`,`id_thematic`),
              KEY `id_thematic` (`id_thematic`)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
            ");
        $result = $wpdb->get_results( "CREATE TABLE IF NOT EXISTS `MonLabo_thematics` (
              `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
              `name_fr` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `name_en` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `wp_post_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `logo` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `external_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `hal_publi_thematic_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              PRIMARY KEY (`id`),
              UNIQUE KEY `id` (`id`)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
            ");
        $result = $wpdb->get_results( "CREATE TABLE IF NOT EXISTS `MonLabo_units` (
              `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
              `affiliations` varchar(200) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `code` varchar(50) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `name_fr` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `name_en` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `wp_post_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `address_alt` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `contact_alt` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `external_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `descartes_publi_unit_id` int(11) DEFAULT NULL,
              `hal_publi_unit_id` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              `logo` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
              PRIMARY KEY (`id`),
              UNIQUE KEY `id` (`id`)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8;
            ");
        $result = $wpdb->get_results( "CREATE TABLE IF NOT EXISTS `MonLabo_units_directors` (
              `id_person` int(11) UNSIGNED NOT NULL,
              `id_unit` int(11) UNSIGNED NOT NULL,
              PRIMARY KEY (`id_person`,`id_unit`),
              KEY `id_unit` (`id_unit`)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
            ");

        $result = $wpdb->get_results( "CREATE TABLE IF NOT EXISTS `MonLabo_mentors` (
              `id_person_supervisor` int(11) UNSIGNED NOT NULL,
              `id_person_student` int(11) UNSIGNED NOT NULL,
              PRIMARY KEY (`id_person_supervisor`,`id_person_student`),
              KEY `id_person_student` (`id_person_student`)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;
        ");

        /*$result = $wpdb->get_results( "ALTER TABLE `MonLabo_mentors`
              ADD CONSTRAINT `MonLabo_mentors_ibfk_1` FOREIGN KEY (`id_person_student`) REFERENCES `MonLabo_persons` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
              ADD CONSTRAINT `MonLabo_mentors_ibfk_2` FOREIGN KEY (`id_person_supervisor`) REFERENCES `MonLabo_persons` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
              ");
        $result = $wpdb->get_results( "ALTER TABLE `MonLabo_teams_members`
              ADD CONSTRAINT `MonLabo_teams_members_ibfk_1` FOREIGN KEY (`id_team`) REFERENCES `MonLabo_teams` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
              ADD CONSTRAINT `MonLabo_teams_members_ibfk_2` FOREIGN KEY (`id_person`) REFERENCES `MonLabo_persons` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
            ");
        $result = $wpdb->get_results( "ALTER TABLE `MonLabo_teams_thematics`
              ADD CONSTRAINT `MonLabo_teams_thematics_ibfk_1` FOREIGN KEY (`id_team`) REFERENCES `MonLabo_teams` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
              ADD CONSTRAINT `MonLabo_teams_thematics_ibfk_2` FOREIGN KEY (`id_thematic`) REFERENCES `MonLabo_thematics` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
              ");
        $result = $wpdb->get_results( "ALTER TABLE `MonLabo_units_directors`
              ADD CONSTRAINT `MonLabo_units_directors_ibfk_1` FOREIGN KEY (`id_unit`) REFERENCES `MonLabo_units` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
              ADD CONSTRAINT `MonLabo_units_directors_ibfk_2` FOREIGN KEY (`id_person`) REFERENCES `MonLabo_persons` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;
        ");*/
        return $this;
    }

    public function fill_tables_with_default_values_if_empty(){
        global $wpdb;
        $MonLabo_access_data=New MonLabo_access_data();
        $empty_MonLabo_persons=false;
        $empty_MonLabo_teams=false;
        $empty_MonLabo_thematics=false;
        $empty_MonLabo_units=false;

        //Adaptation de l'évolution à la version 0.16
        //$result = $wpdb->query("ALTER TABLE `MonLabo_unites` CHANGE `id` `id` SMALLINT( 5 ) UNSIGNED NOT NULL AUTO_INCREMENT ;");

        //Remplir des exemples si les tables sont vides
        $result = $wpdb->get_var( "SELECT COUNT(*) FROM `MonLabo_persons`");
        if (intval($result) === 0) {
            $empty_MonLabo_persons=true;
            $new_person1=Array("id"=>NULL,"wp_post_id"=>"3333", "title"=>"Pr.", "first_name"=>"Prenom_exemple1", "last_name"=>"Nom_exemple1",
                        "category"=>"faculty", "function_en"=>"Direction, PU Paris Descartes", "function_fr"=>"Directrice, PU Paris Descartes",
                        "mail"=>"prenom_exemple1.nom_exemple1@parisdescartes.fr", "phone"=>"33 33",
                        "room"=>"H333", "external_url"=>"", "descartes_publi_author_id"=>'',
                        "uid_ENT_parisdescartes"=>"", "address_alt"=>"", "status"=>"actif", "visible"=>"oui", "hal_publi_author_id"=>"");
            $person3333_id=$MonLabo_access_data->insert_person($new_person1);

            $new_person2= Array("id"=>NULL,"wp_post_id"=>"6666", "title"=>"", "first_name"=>"Prenom_exemple2", "last_name"=>"Nom_exemple2",
                        "category"=>"staff", "function_en"=>"CNRS Engineer", "function_fr"=>"Ingenieur CNRS",
                        "mail"=>"prenom_exemple2.nom_exemple2@parisdescartes.fr", "phone"=>"66 66",
                        "room"=>"H666", "external_url"=>"", "descartes_publi_author_id"=>'',
                        "uid_ENT_parisdescartes"=>"", "address_alt"=>"", "status"=>"actif", "visible"=>"oui", "hal_publi_author_id"=>"");
            $person6666_id=$MonLabo_access_data->insert_person($new_person2);

            $new_person3= Array("id"=>NULL,"wp_post_id"=>"9999", "title"=>"Dr.", "first_name"=>"Prenom_exemple3", "last_name"=>"Nom_exemple3",
                        "category"=>"postdocs", "function_en"=>"Postdoctoral Researcher", "function_fr"=>"Postdoctorant",
                        "mail"=>"prenom_exemple3.nom_exemple3@parisdescartes.fr", "phone"=>"+33 6 16 17 99 99",
                        "room"=>"H999", "external_url"=>"", "descartes_publi_author_id"=>'',
                        "uid_ENT_parisdescartes"=>"", "address_alt"=>"", "status"=>"actif", "visible"=>"oui", "hal_publi_author_id"=>"");
            $person9999_id=$MonLabo_access_data->insert_person($new_person3);
            $MonLabo_access_data->add_mentor_to_a_person($person3333_id,$person9999_id);
            $MonLabo_access_data->add_mentor_to_a_person($person6666_id,$person9999_id);
            $new_person4= Array("id"=>NULL,"wp_post_id"=>"1111", "title"=>"Pr.", "first_name"=>"Prenom_exemple4", "last_name"=>"Nom_exemple4",
                        "category"=>"faculty", "function_en"=>"Direction, PU Paris Descartes", "function_fr"=>"Directrice, PU Paris Descartes",
                        "mail"=>"prenom_exemple4.nom_exemple4@parisdescartes.fr", "phone"=>"11 11",
                        "room"=>"H111", "external_url"=>"", "descartes_publi_author_id"=>'',
                        "uid_ENT_parisdescartes"=>"", "address_alt"=>"", "status"=>"actif", "visible"=>"oui", "hal_publi_author_id"=>"");
            $person1111_id=$MonLabo_access_data->insert_person($new_person4);
        }
        $result = $wpdb->get_var( "SELECT COUNT(*) FROM `MonLabo_teams`");
        if (intval($result) === 0 ) {
            $empty_MonLabo_teams=true;
            $new_team1= Array("id"=>NULL, "name_en"=>'Very complex subject team',
                "name_fr"=>'Equipe au sujet complexe', "wp_post_id"=>'111', "external_url"=>"",
                "descartes_publi_team_id"=>NULL,
                "id_unit"=>"1", "logo"=>NULL, "color"=>"", "hal_publi_team_id"=>"");
            $team1_id=$MonLabo_access_data->insert_team($new_team1);

            $new_team2=   Array("id"=>NULL, "name_en"=>'Direction and support team',
                "name_fr"=>'Direction & personnel de support', "wp_post_id"=>'222', "external_url"=>"",
                "descartes_publi_team_id"=>NULL,
                "id_unit"=>"1", "logo"=>NULL, "color"=>"", "hal_publi_team_id"=>"");
            $team2_id=$MonLabo_access_data->insert_team($new_team2);
        }
        $result = $wpdb->get_var( "SELECT COUNT(*) FROM `MonLabo_thematics`");
        if (intval($result) === 0 ) {
            $empty_MonLabo_thematics=true;
            $new_thematic=   Array("id"=>NULL, "name_fr"=>'Ma thématique n°1',
                                "name_en" => 'My thematics #1',
                                "logo" => 'http://www.666.fr/logo.png',
                                "external_url" => 'http://www.666.fr', "hal_publi_thematic_id"=>"");
            $thematic1_id=$MonLabo_access_data->insert_thematic($new_thematic);
        }
        $result = $wpdb->get_results( "SELECT COUNT(*) AS C FROM `MonLabo_units`");
        if (intval($result[0]->C) === 0 ) {
            $empty_MonLabo_units=true;
            $new_unit=   Array("id"=>NULL, "affiliations"=>'CNRS/Paris Descartes',
                                "code"=> 'UMR0000', "name_fr"=>'Laboratoire pour exemple', "name_en"=>'Example lab',
                                "external_url"=>'http://www.666.fr', "hal_publi_unit_id"=>"");
            $unit1_id=$MonLabo_access_data->insert_unit($new_unit);
        }
        if ($empty_MonLabo_persons and $empty_MonLabo_teams) {
            $MonLabo_access_data->add_person_to_a_team($person3333_id,$team1_id);
            $MonLabo_access_data->add_person_to_a_team($person9999_id,$team1_id);
            $MonLabo_access_data->add_person_to_a_team($person1111_id,$team1_id);

            $MonLabo_access_data->add_person_to_a_team($person3333_id,$team2_id);
            $MonLabo_access_data->add_person_to_a_team($person6666_id,$team2_id);

            $MonLabo_access_data->add_leader_to_a_team($person3333_id,$team1_id);
            $MonLabo_access_data->add_leader_to_a_team($person1111_id,$team1_id);

            $MonLabo_access_data->add_leader_to_a_team($person6666_id,$team2_id);
        }
        if ($empty_MonLabo_thematics and $empty_MonLabo_teams) {
            $MonLabo_access_data->add_thematic_to_a_team($thematic1_id,$team1_id);
        }
        if ($empty_MonLabo_persons and $empty_MonLabo_units) {
            $MonLabo_access_data->add_director_to_an_unit($person3333_id,$unit1_id);
            $MonLabo_access_data->add_director_to_an_unit($person6666_id,$unit1_id);
        }
        return $this;
    }

    public function fill_options_with_custom_values_if_empty($options_DEFAULT){
        global $wpdb;

        //vérifier si les options ont déjà été remplies un jour
        $options_already_filled=false;
        $options0 = get_option( "MonLabo_settings_group0" );
        if((is_array($options0)) && (array_key_exists('MonLabo_activated_version', $options0)) && (!empty($options0['MonLabo_activated_version']))) {
            //On vérifie que les options ont déjà été une fois configurées
            $options_already_filled=true;
        }

        //Set default values of parameters
        foreach ($options_DEFAULT as $group => $options_inOneGroup) {
            $options = get_option( $group );
            if(!is_array($options)) {
                //If array is not defined, set all options of the group to the default ones
                foreach ($options_inOneGroup as $option_name => $option_default_value) {
                    $options[$option_name]=$option_default_value;
                }
            } else {

                //Verify this is not an unchecked checkbox (in this case the value is unset and must not be set to default)
                foreach ($options_inOneGroup as $option_name => $option_default_value) {
                        $protected_value = false;
                        switch ($option_name) { //On recherche les checkbox
                            case "MonLabo_uses_members_and_groups":
                            case "MonLabo_uses_custom_fields_for_staff":
                            case "MonLabo_uses_unites":
                            case "MonLabo_uses_thematiques":
                                if ( ($options_already_filled) //Si les options ont déjà été remplies un jour
                                     && (!array_key_exists($option_name, $options)) // et si on a une checkbox décochée
                                    ) {
                                        # On ne fait rien car par défaut une checkbox à 0 est un champs inexistant. Il ne faut pas l'écraser avec la valeur par défaut
                                        $protected_value=true;
                                }
                            break;
                        }

                    //if this key is not in this array get the default value
                    if ( (!$protected_value) && (!array_key_exists($option_name, $options))) {
                      //if ($options[$option_name]==='') {
                      //echo("valeur par défaut mise pour $option_name (groupe $settings_group).<br />");
                      $options[$option_name]=$option_default_value;
                    }
                }
            }
            update_option($group, $options);
        }

        //Refus de certaines valeurs vides
        $options4 = get_option( 'MonLabo_settings_group4' );
        if (strlen($options4['MonLabo_DescartesPubmed_api_url'])<1) {
            $options4['MonLabo_DescartesPubmed_api_url']=$options_DEFAULT['MonLabo_settings_group4']['MonLabo_DescartesPubmed_api_url'];
        }
        update_option('MonLabo_settings_group4', $options4);
        return $this;
    }


    public function fill_options_with_default_values_if_empty(){
        $this->fill_options_with_custom_values_if_empty(get_options_DEFAULT());
    }

    public function migrate(){
        global $wpdb;
        $row = $wpdb->get_row( $wpdb->prepare( "SELECT option_value FROM $wpdb->options WHERE option_name = %s LIMIT 1", 'MonLabo_settings_group0' ) );
        $option = unserialize($row->option_value);
        //Enter here only if MonLabo_activated_version does not exist or is <=0.60
        if  (
                (!isset($option))
                or (!isset($option["MonLabo_activated_version"]))
                or ( (isset($option["MonLabo_activated_version"])) )
            ) {
            $plugin_version = floatval($option["MonLabo_activated_version"]);
            if ( $plugin_version < 0.93 ) {
                echo("<h1>ERROR: Please migrate your database with version of MonLabo 0.93.</h1>");
            } elseif ( $plugin_version === 0.93 ) {
                $this->migrate_to_version_1_0();
            }
            if ( ($plugin_version < 1.3) and ($plugin_version >= 0.93)) {
                $this->migrate_to_version_1_3();
            }
            if ( ($plugin_version < 1.4) and ($plugin_version >= 0.93)) {
                $this->migrate_to_version_1_4();
            }
            if ( ($plugin_version < 1.6) and ($plugin_version >= 0.93)) {
                $this->migrate_to_version_1_6();
            }
            if ( ($plugin_version < 2.0) and ($plugin_version >= 0.93)) {
                $this->migrate_to_version_2_0();
            }
            if ( ($plugin_version < 2.3) and ($plugin_version >= 0.93)) {
                $this->migrate_to_version_2_3();
            }
            if ( ($plugin_version < 2.4) and ($plugin_version >= 0.93)) {
                $this->migrate_to_version_2_4();
            }
        }
        return $this;
    }

    public function migrate_to_version_1_0(){
        global $wpdb;
        //Adaptation de l'évolution à la version 1.00
        /*if (!is_column_not_exist_in_table("MonLabo_members", "equipes")) { // La colonne equipes existe ?*/
            // creation de la nouvelle table MonLabo_mentors
            $result = $wpdb->query( "CREATE TABLE IF NOT EXISTS `MonLabo_mentors` (
                    `id_person_supervisor` int(11) UNSIGNED NOT NULL,
                    `id_person_student` int(11) UNSIGNED NOT NULL,
                    PRIMARY KEY (`id_person_supervisor`,`id_person_student`),
                    KEY `id_person_student` (`id_person_student`)
                ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;"
            );
            // creation de la nouvelle table MonLabo_persons
            $result = $wpdb->query( "CREATE TABLE IF NOT EXISTS `MonLabo_persons` (
                    `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
                    `wp_post_id` int(11) DEFAULT NULL,
                    `title` varchar(20) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `first_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `last_name` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `category` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `function_fr` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `function_en` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `mail` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `phone` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `room` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `address_alt` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `external_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `descartes_publi_author_id` int(11) DEFAULT NULL,
                    `hal_publi_author_id` varchar(255) DEFAULT NULL,
                    `uid_ENT_parisdescartes` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `date_departure` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `status` varchar(20) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT 'actif',
                    `visible` varchar(3) CHARACTER SET utf8 COLLATE utf8_bin NOT NULL DEFAULT 'oui',
                    `custom1` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `custom2` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `custom3` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `custom4` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `custom5` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `custom6` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `custom7` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `custom8` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `custom9` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `custom10` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `equipes` varchar(20) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `tuteur` varchar(100) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    PRIMARY KEY (`id`),
                    UNIQUE KEY `id` (`id`)
                ) ENGINE=InnoDB DEFAULT CHARSET=utf8;"
            );
            // renommage de la table MonLabo_member en MonLabo_members
            $result = $wpdb->query("ALTER TABLE MonLabo_teams RENAME TO MonLabo_teams_old;");
            // creation de la nouvelle table MonLabo_teams
            $result = $wpdb->query( "CREATE TABLE IF NOT EXISTS `MonLabo_teams` (
                    `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
                    `old_id` int(11) UNSIGNED NOT NULL,
                    `name_fr` varchar(255) DEFAULT NULL,
                    `name_en` varchar(255) DEFAULT NULL,
                    `wp_post_id` varchar(255) DEFAULT NULL,
                    `external_url` varchar(255) DEFAULT NULL,
                    `descartes_publi_team_id` int(11) DEFAULT NULL,
                    `hal_publi_team_id` varchar(255) DEFAULT NULL,
                    `id_unit` int(5) DEFAULT NULL,
                    `logo` varchar(255) DEFAULT NULL,
                    `color` varchar(255) DEFAULT NULL,
                    `leaders` varchar(255) DEFAULT NULL,
                    `thematiques` varchar(255) DEFAULT NULL,
                    PRIMARY KEY (`id`)
                ) ENGINE=InnoDB DEFAULT CHARSET=utf8;"
            );
            // creation de la nouvelle table MonLabo_teams_members
            $result = $wpdb->query( "CREATE TABLE IF NOT EXISTS `MonLabo_teams_members` (
                    `id_person` int(11) UNSIGNED NOT NULL,
                    `id_team` int(11) UNSIGNED NOT NULL,
                    `directing` tinyint(1) NOT NULL DEFAULT '0',
                    PRIMARY KEY (`id_person`,`id_team`),
                    KEY `id_team` (`id_team`)
                ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;"
            );
            // creation de la nouvelle table MonLabo_teams_thematics
            $result = $wpdb->query( "CREATE TABLE IF NOT EXISTS `MonLabo_teams_thematics` (
                    `id_team` int(11) UNSIGNED NOT NULL,
                    `id_thematic` int(11) UNSIGNED NOT NULL,
                    PRIMARY KEY (`id_team`,`id_thematic`),
                    KEY `id_thematic` (`id_thematic`)
                ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;"
            );
            // creation de la nouvelle table MonLabo_thematics
            $result = $wpdb->query( "CREATE TABLE IF NOT EXISTS `MonLabo_thematics` (
                    `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
                    `old_id` int(11) UNSIGNED NOT NULL,
                    `name_fr` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `name_en` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `logo` varchar(255) DEFAULT NULL,
                    `external_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `hal_publi_thematic_id` varchar(255) DEFAULT NULL,
                    PRIMARY KEY (`id`),
                    UNIQUE KEY `id` (`id`)
                ) ENGINE=InnoDB DEFAULT CHARSET=utf8;"
            );
            // creation de la nouvelle table MonLabo_units
            $result = $wpdb->query( "CREATE TABLE IF NOT EXISTS `MonLabo_units` (
                    `id` int(11) UNSIGNED NOT NULL AUTO_INCREMENT,
                    `old_id` int(11) UNSIGNED NOT NULL,
                    `affiliations` varchar(200) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `code` varchar(50) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `name_fr` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `name_en` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `external_url` varchar(255) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL,
                    `hal_publi_unit_id` varchar(255) DEFAULT NULL,
                    `responsable` varchar(100) DEFAULT NULL,
                    PRIMARY KEY (`id`),
                    UNIQUE KEY `id` (`id`)
                ) ENGINE=InnoDB DEFAULT CHARSET=utf8;"
            );
            // creation de la nouvelle table MonLabo_units_directors
            $result = $wpdb->query( "CREATE TABLE IF NOT EXISTS `MonLabo_units_directors` (
                    `id_person` int(11) UNSIGNED NOT NULL,
                    `id_unit` int(11) UNSIGNED NOT NULL,
                    PRIMARY KEY (`id_person`,`id_unit`),
                    KEY `id_unit` (`id_unit`)
                ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COLLATE=utf8_bin;"
            );

            /*// ajout des contraintes sur la table MonLabo_mentors (clé étrangère)
            $result = $wpdb->query( "ALTER TABLE `MonLabo_mentors`
                ADD CONSTRAINT `MonLabo_mentors_ibfk_1` FOREIGN KEY (`id_person_student`) REFERENCES `MonLabo_persons` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
                ADD CONSTRAINT `MonLabo_mentors_ibfk_2` FOREIGN KEY (`id_person_supervisor`) REFERENCES `MonLabo_persons` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;"
            );
            // ajout des contraintes sur la table MonLabo_teams_members (clé étrangère)
            $result = $wpdb->query( "ALTER TABLE `MonLabo_teams_members`
                ADD CONSTRAINT `MonLabo_teams_members_ibfk_1` FOREIGN KEY (`id_team`) REFERENCES `MonLabo_teams` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
                ADD CONSTRAINT `MonLabo_teams_members_ibfk_2` FOREIGN KEY (`id_person`) REFERENCES `MonLabo_persons` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;"
            );
            // ajout des contraintes sur la table MonLabo_teams_thematics (clé étrangère)
            $result = $wpdb->query( "ALTER TABLE `MonLabo_teams_thematics`
                ADD CONSTRAINT `MonLabo_teams_thematics_ibfk_1` FOREIGN KEY (`id_team`) REFERENCES `MonLabo_teams` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
                ADD CONSTRAINT `MonLabo_teams_thematics_ibfk_2` FOREIGN KEY (`id_thematic`) REFERENCES `MonLabo_thematics` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;"
            );
            // ajout des contraintes sur la table MonLabo_units_directors (clé étrangère)
            $result = $wpdb->query( "ALTER TABLE `MonLabo_units_directors`
                ADD CONSTRAINT `MonLabo_units_directors_ibfk_1` FOREIGN KEY (`id_unit`) REFERENCES `MonLabo_units` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
                ADD CONSTRAINT `MonLabo_units_directors_ibfk_2` FOREIGN KEY (`id_person`) REFERENCES `MonLabo_persons` (`id`) ON DELETE CASCADE ON UPDATE CASCADE;"
            );*/

            // transfert des données de l'ancienne table MonLabo_members vers la nouvelle table MonLabo_persons
            $result = $wpdb->get_results("SELECT * FROM `MonLabo_members`", OBJECT_K);
            $table = "MonLabo_persons";
            foreach ($result as $member) {
                $data = array();
                foreach ($member as $key => $value) {
                    switch ($key) {
                        case "id_page_web" :
                            $data["wp_post_id"] = $value;
                            break;
                        case "titre" :
                            $data["title"] = $value;
                            break;
                        case "prenom" :
                            $data["first_name"] = $value;
                            break;
                        case "nom" :
                            $data["last_name"] = $value;
                            break;
                        case "categorie" :
                            $data["category"] = $value;
                            break;
                        case "fonction_en" :
                            $data["function_en"] = $value;
                            break;
                        case "fonction_fr" :
                            $data["function_fr"] = $value;
                            break;
                        case "poste_tel" :
                            $data["phone"] = $value;
                            break;
                        case "porte" :
                            $data["room"] = $value;
                            break;
                        case "adresse_alt" :
                            $data["address_alt"] = $value;
                            break;
                        case "subsite" :
                            $data["external_url"] = $value;
                            break;
                        case "descartes_pubmed_auteur_id" :
                            $data["descartes_publi_author_id"] = $value;
                            break;
                        case "identifiant_ent" :
                            $data["uid_ENT_parisdescartes"] = $value;
                            break;
                        case "date_depart" :
                            $data["date_departure"] = $value;
                            break;
                        case "statut" :
                            $data["status"] = $value;
                            break;
                        default :
                            $data[$key] = $value;
                            break;
                    }
                }
                $wpdb->insert($table, $data);
                /*
                $wpdb->show_errors();
                $wpdb->print_error();
                */
            }
            // suppression de l'ancienne table MonLabo_members
            $result = $wpdb->query("DROP TABLE MonLabo_members;");
            // transfert des données de l'ancienne table MonLabo_teams_old vers la nouvelle table MonLabo_teams
            $result = $wpdb->get_results("SELECT * FROM `MonLabo_teams_old`", OBJECT_K);
            $table = "MonLabo_teams";
            foreach ($result as $member) {
                $data = array();
                foreach ($member as $key => $value) {
                    switch ($key) {
                        case "id" :
                            $data["old_id"] = $value;
                            break;
                        case "page_id_or_url" :
                            $data["wp_post_id"] = $value;
                            break;
                        case "descartes_pubmed_equipe_id" :
                            $data["descartes_publi_team_id"] = $value;
                            break;
                        case "unite" :
                            $data["id_unit"] = $value;
                            break;
                        default :
                            $data[$key] = $value;
                            break;
                    }
                }
                $wpdb->insert($table, $data);
            }
            // suppression de l'ancienne table MonLabo_teams_old
            $result = $wpdb->query("DROP TABLE MonLabo_teams_old;");
            // transfert des données de l'ancienne table MonLabo_thematiques vers la nouvelle table MonLabo_thematics
            $result = $wpdb->get_results("SELECT * FROM `MonLabo_thematiques`", OBJECT_K);
            $table = "MonLabo_thematics";
            foreach ($result as $member) {
                $data = array();
                foreach ($member as $key => $value) {
                    switch ($key) {
                        case "id" :
                            $data["old_id"] = $value;
                            break;
                        case "nom_fr" :
                            $data["name_fr"] = $value;
                            break;
                        case "nom_en" :
                            $data["name_en"] = $value;
                            break;
                        case "url" :
                            $data["external_url"] = $value;
                            break;
                        default :
                            $data[$key] = $value;
                            break;
                    }
                }
                $wpdb->insert($table, $data);
            }
            // suppression de l'ancienne table MonLabo_thematiques
            $result = $wpdb->query("DROP TABLE MonLabo_thematiques;");
            // transfert des données de l'ancienne table MonLabo_unites vers la nouvelle table MonLabo_units
            $result = $wpdb->get_results("SELECT * FROM `MonLabo_unites`", OBJECT_K);
            $table = "MonLabo_units";
            foreach ($result as $member) {
                $data = array();
                foreach ($member as $key => $value) {
                    switch ($key) {
                        case "id" :
                            $data["old_id"] = $value;
                            break;
                        case "nom_fr" :
                            $data["name_fr"] = $value;
                            break;
                        case "nom_en" :
                            $data["name_en"] = $value;
                            break;
                        case "web" :
                            $data["external_url"] = $value;
                            break;
                        default :
                            $data[$key] = $value;
                            break;
                    }
                }
                $wpdb->insert($table, $data);
            }
            // suppression de l'ancienne table MonLabo_unites
            $result = $wpdb->query("DROP TABLE MonLabo_unites;");
            // récupération des valeurs des équipes dont font parti des personnes
            $result = $wpdb->get_results("SELECT id, equipes FROM `MonLabo_persons`", OBJECT_K);
            // remplissage de la nouvelle table MonLabo_teams_members
            $table = "MonLabo_teams_members";
            foreach ($result as $participation) {
                $data = array();
                if ($participation->equipes != "")
                    foreach(explode(",", $participation->equipes) as $equipe) {
                        // récupère le nouvel id de l'equipe
                        $team_id = $wpdb->get_var("SELECT id FROM MonLabo_teams WHERE old_id=".$equipe);
                        $data['id_person'] = $participation->id;
                        $data['id_team'] = $team_id;
                        $data['directing'] = 0;
                        $wpdb->insert($table, $data);
                    }
            }
            // suppression du champ equipes
            $result = $wpdb->query("ALTER TABLE MonLabo_persons DROP COLUMN equipes;");
            // récupération des valeurs des tuteurs encadrant des personnes
            $result = $wpdb->get_results("SELECT id, tuteur FROM `MonLabo_persons`", OBJECT_K);
            // remplissage de la nouvelle table MonLabo_mentors
            $table = "MonLabo_mentors";
            foreach ($result as $student) {
                if ($student->tuteur != "")
                    foreach(explode(",", $student->tuteur) as $supervisor) {
                        $data = array();
                        // récupère le nouvel id du supervisor
                        $supervisor_id = $wpdb->get_var("SELECT id FROM MonLabo_persons WHERE wp_post_id=".$supervisor);
                        $data = array();
                        $data['id_person_supervisor'] = $supervisor_id;
                        $data['id_person_student'] = $student->id;
                        $wpdb->insert($table, $data);
                    }
            }
            // suppression du champ tuteur
            $result = $wpdb->query("ALTER TABLE MonLabo_persons DROP COLUMN tuteur;");
            // récupération des valeurs des anciens champs
            $result = $wpdb->get_results("SELECT id, leaders FROM `MonLabo_teams`", OBJECT_K);
            // modification de la nouvelle table MonLabo_teams_members
            $table = "MonLabo_teams_members";
            $data = array();
            $data['directing'] = 1;
            foreach ($result as $line) {
                if ($line->leaders != "")
                    foreach(explode(",", $line->leaders) as $director) {
                        // récupère le nouvel id du directeur
                        $director_id = $wpdb->get_var("SELECT id FROM MonLabo_persons WHERE wp_post_id=".$director);
                        // modifie la ligne
                        $where = array();
                        $where['id_person'] = $director_id;
                        $where['id_team'] = $line->id;
                        $wpdb->update($table, $data, $where);
                    }
            }
            // suppression du champ leaders
            $result = $wpdb->query("ALTER TABLE MonLabo_teams DROP COLUMN leaders;");
            // récupération des valeurs des anciens champs
            $result = $wpdb->get_results("SELECT id, thematiques FROM `MonLabo_teams`", OBJECT_K);
            // remplissage de la nouvelle table MonLabo_teams_thematics
            $table = "MonLabo_teams_thematics";
            foreach ($result as $line) {
                if ($line->thematiques != "")
                    foreach(explode(",", $line->thematiques) as $thematic) {
                        // récupère le nouvel id de la thématique
                        $thematic_id = $wpdb->get_var("SELECT id FROM MonLabo_thematics WHERE old_id=".$thematic);
                        $data = array();
                        $data['id_team'] = $line->id;
                        $data['id_thematic'] = $thematic_id;
                        $wpdb->insert($table, $data);
                    }
            }
            // suppression du champ thematiques
            $result = $wpdb->query("ALTER TABLE MonLabo_teams DROP COLUMN thematiques;");
            // récupération des valeurs des anciens champs
            $result = $wpdb->get_results("SELECT id, responsable FROM `MonLabo_units`", OBJECT_K);
            // remplissage de la nouvelle table MonLabo_units_directors
            $table = "MonLabo_units_directors";
            foreach ($result as $line) {
                if ($line->responsable === "Nom du responsable")
                    $line->responsable = 1;
                if ($line->responsable != "")
                    foreach(explode(",", $line->responsable) as $responsable) {
                        // récupère le nouvel id du responsable
                        $director_id = $wpdb->get_var("SELECT id FROM MonLabo_persons WHERE wp_post_id=".$responsable);
                        $data = array();
                        $data['id_unit'] = $line->id;
                        if (!empty($director_id)) {
                            $data['id_person'] = $director_id;
                            $wpdb->insert($table, $data);
                        }
                    }
            }
            // suppression du champ responsable
            $result = $wpdb->query("ALTER TABLE MonLabo_units DROP COLUMN responsable;");
            // récupération les id des équipes dont wp_post_id est une URL et non un ID ou liste d'ID
            $result = $wpdb->get_results("SELECT id, wp_post_id FROM MonLabo_teams WHERE wp_post_id LIKE 'http%'", OBJECT_K);
            foreach ($result as $line) {
                // on le met dans le champ external_url
                $result = $wpdb->get_results("UPDATE MonLabo_teams SET external_url = ".$line->wp_post_id." WHERE id = ".$line->id.";", OBJECT_K);
                // on le supprime de wp_post_id
                $result = $wpdb->get_results("UPDATE MonLabo_teams SET wp_post_id = '' WHERE id = ".$line->id.";", OBJECT_K);
            }
            // suppression du champ old_id de la table MonLabo_teams
            $result = $wpdb->query("ALTER TABLE MonLabo_teams DROP COLUMN old_id;");
            // suppression du champ old_id de la table MonLabo_thematics
            $result = $wpdb->query("ALTER TABLE MonLabo_thematics DROP COLUMN old_id;");
            // suppression du champ old_id de la table MonLabo_units
            $result = $wpdb->query("ALTER TABLE MonLabo_units DROP COLUMN old_id;");
    //    }
    }

    public function migrate_to_version_1_3(){
        global $wpdb;
        //Ajout de la colone descartes_publi_unit_id dans MonLabo_units
        if (!is_column_exist_in_table("MonLabo_units", "descartes_publi_unit_id")) { //La colonne descartes_publi_unit_id n'existe pas?
            $result = $wpdb->query("ALTER TABLE `MonLabo_units` ADD `descartes_publi_unit_id` INT(11) NULL DEFAULT NULL AFTER `external_url`;");
        }
        //Ajout de la colone logo dans MonLabo_units
        if (!is_column_exist_in_table("MonLabo_units", "logo")) { //La colonne logo n'existe pas?
            $result = $wpdb->query("ALTER TABLE `MonLabo_units` ADD `logo` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL AFTER `hal_publi_unit_id`;");
        }
    }

    public function migrate_to_version_1_4(){
        global $wpdb;
        // changement du type int en varchar pour les hal_publi_*
        if (is_column_as_type_in_table("MonLabo_persons", "hal_publi_author_id", "int(11)")) {
          //ALTER TABLE `monlabo_persons` CHANGE `hal_publi_author_id` `hal_publi_author_id` VARCHAR(255) NULL DEFAULT NULL;
            $result = $wpdb->query("ALTER TABLE `MonLabo_persons` CHANGE `hal_publi_author_id` `hal_publi_author_id` VARCHAR(255) NULL DEFAULT NULL;");
        }
        if (is_column_as_type_in_table("MonLabo_teams", "hal_publi_team_id", "int(11)")) {
          //ALTER TABLE `monlabo_persons` CHANGE `hal_publi_author_id` `hal_publi_author_id` VARCHAR(255) NULL DEFAULT NULL;
            $result = $wpdb->query("ALTER TABLE `MonLabo_teams` CHANGE `hal_publi_team_id` `hal_publi_team_id` VARCHAR(255) NULL DEFAULT NULL;");
        }
        if (is_column_as_type_in_table("MonLabo_thematics", "hal_publi_thematic_id", "int(11)")) {
          //ALTER TABLE `monlabo_persons` CHANGE `hal_publi_author_id` `hal_publi_author_id` VARCHAR(255) NULL DEFAULT NULL;
            $result = $wpdb->query("ALTER TABLE `MonLabo_thematics` CHANGE `hal_publi_thematic_id` `hal_publi_thematic_id` VARCHAR(255) NULL DEFAULT NULL;");
        }
        if (is_column_as_type_in_table("MonLabo_units", "hal_publi_unit_id", "int(11)")) {
          //ALTER TABLE `monlabo_persons` CHANGE `hal_publi_author_id` `hal_publi_author_id` VARCHAR(255) NULL DEFAULT NULL;
            $result = $wpdb->query("ALTER TABLE `MonLabo_units` CHANGE `hal_publi_unit_id` `hal_publi_unit_id` VARCHAR(255) NULL DEFAULT NULL;");
        }
    }


    public function migrate_to_version_1_6(){
        global $wpdb;
        $MonLabo_access_data=New MonLabo_access_data();

        // 1 -Les categories "direction" sont remplacée par "faculty" + un lien dans MonLabo_units_directors
        if (is_column_exist_in_table("MonLabo_persons", "category")) {
            $all_active_persons=$MonLabo_access_data->get_persons_information();
            foreach ($all_active_persons as $person) {
                //pour toutes les personnes de la direction
                if($person->category === "direction") {
                    // A - Les mettre dans la catégorie faculty
                    $MonLabo_access_data->update_person($person->id, array("category"=>"faculty"));
                    // B - Les mettre en tant que directeur des unités des équipes auxquelles il appartient
                    $teams_id=$MonLabo_access_data->get_teams_id_for_a_person($person->id);
                    if(!empty($teams_id)) {
                        foreach ($teams_id as $team_id) {
                            $team=$MonLabo_access_data->get_team_information($team_id);
                            if(!is_null($team->id_unit)) {
                                $MonLabo_access_data->add_director_to_an_unit ($person->id, $team->id_unit);
                            } else {
                                //Dans le cas où l'unité n'a jamais été affectée:
                                // a) Affecter à l'unité 1 l'équipe non affectée
                                // b) Ajouter la personne comme directeur de cette unité
                                $MonLabo_access_data->update_team($team_id, array("id_unit"=>MAIN_STRUCT_NO_UNIT));
                                $MonLabo_access_data->add_director_to_an_unit ($person->id, MAIN_STRUCT_NO_UNIT);
                            }
                        }
                    }
                }
            }
        }

        // 2 - Si les clefs étrangères existent encore, les supprimer car elles sont obsolètes:
        // NB: Ne fonctionne pas partout... grrrrrr. N'est pas essentiel. Tant pis.
        /*$this->suppress_foreign_key_if_exists("MonLabo_mentors_ibfk_1", "MonLabo_mentors");
        $this->suppress_foreign_key_if_exists("MonLabo_mentors_ibfk_2", "MonLabo_mentors");
        $this->suppress_foreign_key_if_exists("MonLabo_teams_members_ibfk_1", "MonLabo_teams_members");
        $this->suppress_foreign_key_if_exists("MonLabo_teams_members_ibfk_2", "MonLabo_teams_members");
        $this->suppress_foreign_key_if_exists("MonLabo_teams_thematics_ibfk_1", "MonLabo_teams_thematics");
        $this->suppress_foreign_key_if_exists("MonLabo_teams_thematics_ibfk_2", "MonLabo_teams_thematics");
        $this->suppress_foreign_key_if_exists("MonLabo_units_directors_ibfk_1", "MonLabo_units_directors");
        $this->suppress_foreign_key_if_exists("MonLabo_units_directors_ibfk_2", "MonLabo_units_directors");*/

        // 3 - Si une équipe n'a pas de laboratoire d'appartenance, alors la ratacher à la structure principale
        $all_teams=$MonLabo_access_data->get_teams_information();
        if(!empty($all_teams)) {
            foreach ($all_teams as $team) {
                if(is_null($team->id_unit)) {
                    $MonLabo_access_data->update_team($team->id, array("id_unit"=>MAIN_STRUCT_NO_UNIT));
                }
            }
        }
    }

    public function migrate_to_version_2_0(){
        global $wpdb;
        //Ajout de la colone wp_post_id dans MonLabo_units
        if (!is_column_exist_in_table("MonLabo_units", "wp_post_id")) { //La colonne logo n'existe pas?
            $result = $wpdb->query("ALTER TABLE `MonLabo_units` ADD `wp_post_id` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL AFTER `name_en`;");
        }
        //Ajout de la colone wp_post_id dans MonLabo_thematics
        if (!is_column_exist_in_table("MonLabo_thematics", "wp_post_id")) { //La colonne logo n'existe pas?
            $result = $wpdb->query("ALTER TABLE `MonLabo_thematics` ADD `wp_post_id` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL AFTER `name_en`;");
        }
        $result = $wpdb->query("ALTER TABLE `MonLabo_persons` CHANGE `wp_post_id` `wp_post_id` VARCHAR(255)  CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL;");

        //Renomme l'option "MonLabo_fax_ou_contact" en "MonLabo_contact"
        $options1 = get_option( 'MonLabo_settings_group1' );
        if(array_key_exists('MonLabo_fax_ou_contact', $options1)) {
            $options1['MonLabo_contact']=$options1['MonLabo_fax_ou_contact'];
            unset($options1['MonLabo_fax_ou_contact']);
        }
        delete_option('MonLabo_settings_group1');
        update_option('MonLabo_settings_group1', $options1);

        //Ajout des colonnes address_alt et contact_alt dans MonLabo_units
        if (!is_column_exist_in_table("MonLabo_units", "contact_alt")) { //La colonne logo n'existe pas?
            $result = $wpdb->query("ALTER TABLE `MonLabo_units` ADD `contact_alt` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL AFTER `wp_post_id`;");
        }
        if (!is_column_exist_in_table("MonLabo_units", "address_alt")) { //La colonne logo n'existe pas?
            $result = $wpdb->query("ALTER TABLE `MonLabo_units` ADD `address_alt` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL AFTER `wp_post_id`;");
        }

        //Passage en UTF8 des colones qui n'ont pas encore été faites
        $result = $wpdb->query("ALTER TABLE `MonLabo_thematics` CHANGE `wp_post_id` `wp_post_id` VARCHAR(255)  CHARACTER SET utf8 COLLATE utf8_bin NULL DEFAULT NULL;");
        $result = $wpdb->query("ALTER TABLE `MonLabo_thematics` CHANGE `logo` `logo` VARCHAR(255)  CHARACTER SET utf8 COLLATE utf8_bin NULL DEFAULT NULL;");
        $result = $wpdb->query("ALTER TABLE `MonLabo_thematics` CHANGE `hal_publi_thematic_id` `hal_publi_thematic_id` VARCHAR(255)  CHARACTER SET utf8 COLLATE utf8_bin NULL DEFAULT NULL;");
        $result = $wpdb->query("ALTER TABLE `MonLabo_units` CHANGE `hal_publi_unit_id` `hal_publi_unit_id` VARCHAR(255)  CHARACTER SET utf8 COLLATE utf8_bin NULL DEFAULT NULL;");
        $result = $wpdb->query("ALTER TABLE `MonLabo_units` CHANGE `logo` `logo` VARCHAR(255)  CHARACTER SET utf8 COLLATE utf8_bin NULL DEFAULT NULL;");
    }

    public function migrate_to_version_2_3(){
        global $wpdb;
        // 1 - Transforme les options "MonLabo_uses_publications", "MonLabo_uses_hal_publi" et "MonLabo_uses_descartes_publi"
        //     en une seule option exclusive "MonLabo_publication_server_type"
        // 2 - Supprime l'option "MonLabo_uses_advanced_features"
        $options0 = get_option( 'MonLabo_settings_group0' );
        $options4 = get_option( 'MonLabo_settings_group4' );
        if (isset($options0["MonLabo_uses_publications"]) && (intval($options0["MonLabo_uses_publications"])===1)) {
            if (isset($options4["MonLabo_uses_descartes_publi"]) && (intval($options4["MonLabo_uses_descartes_publi"])===1)) {
                $options0["MonLabo_publication_server_type"]="DescartesPubli";
            } elseif (isset($options4["MonLabo_uses_hal_publi"]) && (intval($options4["MonLabo_uses_hal_publi"])===1)) {
                $options0["MonLabo_publication_server_type"]="hal";
            } else {
                $options0["MonLabo_publication_server_type"]="aucun";
            }
        } else {
            $options0["MonLabo_publication_server_type"]="aucun";
        }
        unset($options0['MonLabo_uses_publications']);
        unset($options0['MonLabo_uses_advanced_features']);
        unset($options4['MonLabo_uses_hal_publi']);
        unset($options4['MonLabo_uses_descartes_publi']);
        delete_option('MonLabo_settings_group0');
        update_option('MonLabo_settings_group0', $options0);
        delete_option('MonLabo_settings_group4');
        update_option('MonLabo_settings_group4', $options4);
    }

    public function migrate_to_version_2_4(){
        global $wpdb;
        //Ajout de la colone alternate_image dans MonLabo_persons
        if (!is_column_exist_in_table("MonLabo_persons", "alternate_image")) { //La colonne logo n'existe pas?
            $result = $wpdb->query("ALTER TABLE `MonLabo_persons` ADD `alternate_image` VARCHAR( 255 ) CHARACTER SET utf8 COLLATE utf8_bin DEFAULT NULL AFTER `custom10`;");
        }
    }

    private function suppress_foreign_key_if_exists($key, $table){
        // NB: Ne fonctionne pas partout... grrrrrr.  N'est pas essentiel. Tant pis.
        global $wpdb;
        $sql="set @varfkml=if((SELECT true FROM information_schema.TABLE_CONSTRAINTS WHERE "
            . "CONSTRAINT_SCHEMA = DATABASE() AND "
            . "TABLE_NAME        = '".$table."' AND "
            . "CONSTRAINT_NAME   = '".$key."' AND "
            . "CONSTRAINT_TYPE   = 'FOREIGN KEY') = true,'ALTER TABLE `".$table."` "
            . "drop foreign key `".$key."`','select 1'); "
            . "prepare stmt from @varfkml; "
            . "execute stmt; "
            . "deallocate prepare stmt;";

        $result = $wpdb->query($sql);
    }

    public function delete_options(){
        //Effacer les options
        delete_option('MonLabo_settings_group0');
        delete_option('MonLabo_settings_group1');
        delete_option('MonLabo_settings_group2');
        delete_option('MonLabo_settings_group3');
        delete_option('MonLabo_settings_group4');
        return $this;
    }


    public function delete_tables(){
        global $wpdb;
        //Effacer les tables
        $result = $wpdb->get_results( "DROP TABLE IF EXISTS `MonLabo_persons`, `MonLabo_teams`, `MonLabo_thematics`, `MonLabo_units`, `MonLabo_mentors`, `MonLabo_units_directors`, `MonLabo_teams_members`, `MonLabo_teams_thematics`;");
        //Folowing line to delete when migrated to V1.0
        $result = $wpdb->get_results( "DROP TABLE IF EXISTS `MonLabo_members`, `MonLabo_teams`, `MonLabo_thematiques`, `MonLabo_unites`;");
        return $this;
    }
}
