<?php
/**
 *
 * This file runs when the plugin in uninstalled (deleted).
 * This will not run when the plugin is deactivated.
 * Ideally you will add all your clean-up scripts here
 * that will clean-up unused meta, options, etc. in the database.
 *
 */

// Do something here if plugin is being uninstalled.
// If uninstall is not called from WordPress, exit
if ( !defined( 'WP_UNINSTALL_PLUGIN' ) ) {
    exit();
}

require_once( dirname(__FILE__) . '/includes/MonLabo_db.php' );

$MonLabo_DB = New MonLabo_db();
$MonLabo_DB->delete_options(); //Effacer les options
$MonLabo_DB->delete_tables(); //Effacer les tables
