<?php
///////////////////////////////////////////////////////////////////////////////////////////
//                       DEFAULT PARAM VALUES
///////////////////////////////////////////////////////////////////////////////////////////

function get_options_DEFAULT(){
    return array(
        "MonLabo_settings_group0" => array(
                                            "MonLabo_activated_version"             => "0",
                                            "MonLabo_publication_server_type"       => "hal",
                                            "MonLabo_uses_members_and_groups"       => "1",
                                            "MonLabo_uses_custom_fields_for_staff"  => "0",
                                            "MonLabo_uses_unites"                   => "0",
                                            "MonLabo_uses_thematiques"              => "0",
                                            "MonLabo_teamGroupName_fr"              => "Thématique",
                                            "MonLabo_teamGroupName_fr_pl"           => "Thématiques",
                                            "MonLabo_teamGroupName_en"              => "Thematic",
                                            "MonLabo_teamGroupName_en_pl"           => "Thematics",
        ),
        "MonLabo_settings_group1" => array(
                                            "MonLabo_nom"       => "Centre de Neurophysique, Physiologie et Pathologie",
                                            "MonLabo_code"      => "CNRS UMR 8119",
                                            "MonLabo_adresse"   => "Université Paris Descartes
45 Rue des Saints Pères
75270 Paris Cedex 06
France",
                                            "MonLabo_prefixe_tel"           => "+33 1 42 86",
                                            "MonLabo_contact"               => "Fax : +33 (0) 1 42 86 20 80",
                                            "MonLabo_hal_publi_struct_id"   => "44477,9310",
                                            /*"MonLabo_accept_survey"         => "1",
                                            "MonLabo_plugin_info_email"     => "",*/
        ),
        "MonLabo_settings_group2" => array(
                                            "MonLabo_perso_page_parent"     => "",
                                            "MonLabo_foreground_color"      => "#00a4db",
                                            "MonLabo_address_color"         => "#aaaaaa",
                                            "MonLabo_address_size"          => "10px",
                                            "MonLabo_address_block_width"   => "180px",
                                            "MonLabo_perso_panel_width"     => "667px",
                                            "MonLabo_name_size"             => "26px",
                                            "MonLabo_img_arrondi"           => "50%",
                                            "MonLabo_img_par_defaut"        => plugins_url('MonLabo/images/photo_par_defaut.png'),
                                            "MonLabo_custom_css"           => "",
        ),

        "MonLabo_settings_group3" => array(
                                            "MonLabo_custom_fields_number"    => "1",
                                            "MonLabo_custom_field1_title"     => "",
                                            "MonLabo_custom_field2_title"     => "",
                                            "MonLabo_custom_field3_title"     => "",
                                            "MonLabo_custom_field4_title"     => "",
                                            "MonLabo_custom_field5_title"     => "",
                                            "MonLabo_custom_field6_title"     => "",
                                            "MonLabo_custom_field7_title"     => "",
                                            "MonLabo_custom_field8_title"     => "",
                                            "MonLabo_custom_field9_title"     => "",
                                            "MonLabo_custom_field10_title"    => "",
        ),

        "MonLabo_settings_group4" => array(
                                            "MonLabo_hal_publi_style"    => "hal",
                                            "MonLabo_DescartesPubmed_api_url" => "https://www.biomedicale.univ-paris5.fr/ufr/publications/API_publique.php",
                                            "MonLabo_DescartesPubmed_format"  => "html_default",
        ),

        "MonLabo_settings_group5" => array(
                                            "MonLabo_custom_text_Personal_website_en"       => "Personal website",
                                            "MonLabo_custom_text_Personal_website_fr"       => "Site personnel",
                                            "MonLabo_custom_text_Recent_Publications_en"    => "Recent Publications",
                                            "MonLabo_custom_text_Recent_Publications_fr"    => "Dernières Publications",
                                            "MonLabo_custom_text_Team_leader_en"            => 'Team leader',
                                            "MonLabo_custom_text_Team_leader_fr"            => 'Chef d&apos;équipe',
                                            "MonLabo_custom_text_Team_leaders_en"           => 'Team leaders',
                                            "MonLabo_custom_text_Team_leaders_fr"           => 'Chefs d&apos;équipe',
                                            "MonLabo_custom_text_Faculty_en"                => 'Faculty',
                                            "MonLabo_custom_text_Faculty_fr"                => 'Chercheurs permanents',
                                            "MonLabo_custom_text_Staff_en"                  => 'Support staff',
                                            "MonLabo_custom_text_Staff_fr"                  => 'Ingénieurs et techniciens',
                                            "MonLabo_custom_text_Postdocs_en"               => 'Postdocs',
                                            "MonLabo_custom_text_Postdocs_fr"               => 'Postdocs',
                                            "MonLabo_custom_text_Students_en"               => 'Students',
                                            "MonLabo_custom_text_Students_fr"               => 'Étudiants',
                                            "MonLabo_custom_text_Visitors_en"               => 'Visitors',
                                            "MonLabo_custom_text_Visitors_fr"               => 'Visiteurs',
        ),

    );
}

function get_MonLabo_Members_fields_comments($field) {
    $options4=get_option( 'MonLabo_settings_group4' );
    $MonLabo_Members_fields_comments = array(
            "wp_post_id" => __("Numéro de la page de l&apos;utilisateur", "MonLabo"),
            "title" => "", //"Titre (ex: Pr., Dr.) affiché sur la page personnelle",
            "first_name" => "",
            "last_name" => "",
            "category" => "", //"Catégorie de personnel (faculty, postdocs, students, staff, visitors ou vide)",
            "function_en" => __("Emploi, fonction de la personne en anglais", "MonLabo"),
            "function_fr" => __("Emploi, fonction de la personne en français", "MonLabo"),
            "teams" => "", //"Numéro de l'équipe (plusieurs numéros possibles séparés par des virgules)",
            "mentors" => __("Possibilité de sélectionner plusieurs lignes avec CTRL", "MonLabo"), //"Page ID de l'encadrant d'un étudiant (plusieurs numéros possibles séparés par des virgules)",
            "students" => __("Possibilité de sélectionner plusieurs lignes avec CTRL", "MonLabo"), //"Page ID de l'encadrant d'un étudiant (plusieurs numéros possibles séparés par des virgules)",
            "mail" => "",
            "phone" => __("Poste téléphonique (entrer un numéro commençant par + pour que le préfixe ne soit pas utilisé)", "MonLabo"),
            "room" => "", //"Numéro de porte",
            "address_alt" => __("Adresse éventuelle de remplacement de celle de la structure.", "MonLabo"),
            "external_url" => "", //"Eventuel site personnel de l'utilisateur à faire apparaitre sur la page perso",
            "descartes_publi_author_id" => __("Numéro d&apos;auteur dans la base Descartes Publi pour pouvoir afficher les publications", "MonLabo"). " (<a href='".$options4['MonLabo_DescartesPubmed_api_url']."?html_userslist'>".__("liste consultable ici","MonLabo")."</a>)",
            "hal_publi_author_id" => __("idHAL pour pouvoir afficher les publications", "MonLabo"). " (<a href='https://aurehal.archives-ouvertes.fr/author'>".__("liste consultable ici","MonLabo")."</a>)",
            "uid_ENT_parisdescartes" => __("Identifiant ParisDescartes (peut servir de login de connexion)", "MonLabo"),
            "date_departure" => __("Date ou année de départ de la structure (utile pour les alumni)", "MonLabo"),
            "status" => "", //"actif ou alumni",
            "visible" => "" //"Mettre 'non' pour que cette personne n'apparaisse pas sur le site."
        );
    if (array_key_exists($field, $MonLabo_Members_fields_comments)) {
        return $MonLabo_Members_fields_comments[$field];
    } else {
        return "";
    }
}

function get_MonLabo_Team_fields_comments($field) {
    $options4=get_option( 'MonLabo_settings_group4' );
    $MonLabo_Team_fields_comments = array(
       "id" => __("Numéro d&apos;identifiant de l&apos;équipe qui s&apos;incrémente automatiquement", "MonLabo"),
       "name_en" => __("Nom de l&apos;équipe en anglais",  "MonLabo"),
       "name_fr" => __("Nom de l&apos;équipe en français",  "MonLabo"),
       "wp_post_id" => __("ID des pages de l&apos;équipe (numéros séparés par des virgules, remplacable éventuellement par des URL)", "MonLabo"),
       "external_url" => __("Lien extérieur éventuel", "MonLabo"),
       "descartes_publi_team_id" => __("Numéro d&apos;équipe dans la base Descartes Publi pour pouvoir afficher les publications", "MonLabo")." (<a href='".$options4['MonLabo_DescartesPubmed_api_url']."?html_teamslist'>".__("liste consultable ici", "MonLabo")."</a>)",
       "hal_publi_team_id" => __("Identifiants pour pouvoir afficher les publications (numéros séparés par des virgules)", "MonLabo"). " (<a href='https://aurehal.archives-ouvertes.fr/structure'>".__("liste consultable ici","MonLabo")."</a>) ".__("Si vide, MonLabo utilisera les idHal de chaque membre de l&apos;équipe.","MonLabo"),
       "leaders" => __("Nom des responsables de l&apos;équipe", "MonLabo"),
       "id_unit" => "",
       "logo" => __("Logo <small>(par défaut ce sera le logo de l&apos;unité)</small>", "MonLabo"),
       "color" => __("Couleur de l&apos;équipe (utilisé dans [members_chart], [members_table] et [team_panel])", "MonLabo"),
       "thematics" => __("Liste des groupes auxquels appartient l&apos;équipe (sélection multiple)", "MonLabo")
    );
    if (array_key_exists($field, $MonLabo_Team_fields_comments)) {
        return $MonLabo_Team_fields_comments[$field];
    } else {
        return "";
    }
}

function get_MonLabo_Thematic_fields_comments($field) {
    $MonLabo_Thematic_fields_comments = array(
       "id" => __("Numéro d&apos;identifiant du groupe d&apos;équipes qui s'incrémente automatiquement", "MonLabo"),
       "name_fr" => __("Nom français du groupe d&apos;équipes", "MonLabo"),
       "name_en" => __("Nom anglais du groupe d&apos;équipes", "MonLabo"),
       "logo" => __("Logo", "MonLabo"),
       "wp_post_id" => __("ID des pages du groupe d&apos;équipes (numéros séparés par des virgules, remplacable éventuellement par des URL)", "MonLabo"),
       "hal_publi_thematic_id" => __("Identifiants pour pouvoir afficher les publications (numéros séparés par des virgules)", "MonLabo"). " (<a href='https://aurehal.archives-ouvertes.fr/structure'>".__("liste consultable ici","MonLabo")."</a>)",
       "external_url" => __("Adresse de la page du groupe d&apos;équipes (optionnel)", "MonLabo")
    );
    if (array_key_exists($field, $MonLabo_Thematic_fields_comments)) {
        return $MonLabo_Thematic_fields_comments[$field];
    } else {
        return "";
    }
}

function get_MonLabo_Unite_fields_comments($field) {
    $options4=get_option( 'MonLabo_settings_group4' );
    $MonLabo_Unite_fields_comments = array(
       "id" => __("Numéro d&apos;identifiant de l&apos;unité qui s'incrémente automatiquement", "MonLabo"),
       "affiliations" => __("Structures d&apos;affiliation du laboratoire", "MonLabo"),
       "code" => __("Code laboratoire (ex: CNRS UMR 8119)", "MonLabo"),
       "name_fr" => __("Nom du laboratoire en français", "MonLabo"),
       "name_en" => __("Nom du laboratoire en anglais", "MonLabo"),
       "wp_post_id" => __("ID des pages de l&apos;unité (numéros séparés par des virgules, remplacable éventuellement par des URL)", "MonLabo"),
       "directors" => __("Nom du/des Directeur(s) du laboratoire", "MonLabo"),
       "external_url" => __("Adresse du site du laboratoire", "MonLabo"),
       "descartes_publi_unit_id" => __("Numéro d&apos;unité dans la base Descartes Publi pour pouvoir afficher les publications", "MonLabo")." (<a href='".$options4['MonLabo_DescartesPubmed_api_url']."?html_unitlist'>".__("liste consultable ici", "MonLabo")."</a>)",
       "hal_publi_unit_id" => __("Identifiants pour pouvoir afficher les publications (numéros séparés par des virgules)", "MonLabo"). " (<a href='https://aurehal.archives-ouvertes.fr/structure'>".__("liste consultable ici","MonLabo")."</a>) ".__("Si vide, MonLabo utilisera les idHal de chaque membre de l&apos;unité.","MonLabo"),
       "logo" => __("Logo", "MonLabo"),
       "address_alt" => __("Adressse alternative (si différente de l&apos;adresse de la structure principale)", "MonLabo"),
       "contact_alt" => __("Contact alternatif par mail, téléphone, fax ou autre moyen (si différent du contact de la structure principale)", "MonLabo")
    );
    if (array_key_exists($field, $MonLabo_Unite_fields_comments)) {
        return $MonLabo_Unite_fields_comments[$field];
    } else {
        return "";
    }
}


function get_MonLabo_Structure_principale_fields_comments($field) {
    $MonLabo_Structure_principale_fields_comments = array(
        "nom" => __("Nom de la structure principale<br />(ex: <em>Centre sur l&apos;étude de la téléportation et des miettes de pain</em>).", "MonLabo"),
        "code" => __("Code de cette structure<br />(ex: <em>UMR 666</em>).", "MonLabo"),
        "adresse" => __("Adresse de cette structure<br />(ex: <em>Université bidule<br>160 rue du bout du chemin<br />00000 Nulle-part-sur-mer<br />France</em>).", "MonLabo"),
        "prefixe_tel" => __("Préfixe téléphonique de la structure<br />(ex: <em>+33 1 42 86 </em>).", "MonLabo"),
        "contact" => __("Contact par mail, téléphone, fax ou autre moyen<br />(ex: <em>Fax : +33 (0) 1 42 86 20 80</em>).", "MonLabo"),
        "hal_publi_struct_id" => __("ID HAL de la structure", "MonLabo")." ".__("(numéros séparés par des virgules)", "MonLabo"). " <a href='https://aurehal.archives-ouvertes.fr/structure'>".__("liste consultable ici","MonLabo")."</a>",
        "directors" => __("Nom des directeurs et directrices de la structure ", "MonLabo"),
    );
    if (array_key_exists($field, $MonLabo_Structure_principale_fields_comments)) {
        return $MonLabo_Structure_principale_fields_comments[$field];
    } else {
        return "";
    }
}

function get_MonLabo_MembersFunctionsByCategory_default() {
    return array(
        "faculty" => Array(
                        "Assistant Professor | Maître de Conférences",
                        "Professor | Professeur",
                        "Professor Emeritus | Professeur Émérite",
                        "Research Scientist | Chargé de Recherche",
                        "Senior Research Scientist | Directeur de Recherche"
                    ),
        "staff" => Array(
                        "Administrative Assistant | Adjoint Administratif",
                        "Assistant Engineer | Assistant Ingénieur",
                        "Engineer | Ingénieur d’Études",
                        "Senior Engineer | Ingénieur de Recherche",
                        "Technician | Technicien",
                        "Technical assistant | Adjoint Technique"
                    ),
        "postdocs" => Array(
                        "Postdoctoral Researcher | Postdoctorant"
                    ),
        "students" => Array(
                        "Doctoral Student | Doctorant",
                        "Master Student | Étudiant de Master"
                    ),
        "visitors" => Array(
                        "Visitor | Visiteur",
                    ),
            );
}

function get_MonLabo_persons_categories() {
    return array("faculty" => "faculty",
              "staff" => "staff",
              "postdocs" => "postdocs",
              "students" => "students",
              "visitors" => "visitors"
        );
}

define("MAIN_STRUCT_NO_UNIT",     "99999");
?>
